﻿/// <autosync enabled="true" />
/// <reference path="../customspace/custom.js" />
/// <reference path="../customspace/views/view-example.js" />
/// <reference path="../customspace/views/viewpanels/articlelist-example.js" />
/// <reference path="../customspace/views/viewpanels/html-example.js" />
/// <reference path="../customspace/views/viewpanels/trend-example.js" />
/// <reference path="../customspaceexamples/incident.js" />
/// <reference path="../gruntfile.js" />
/// <reference path="administration/announcement.js" />
/// <reference path="app/app.api.js" />
/// <reference path="app/app.constants.js" />
/// <reference path="app/app.controls.js" />
/// <reference path="app/app.datamodels.js" />
/// <reference path="app/app.js" />
/// <reference path="app/app.lib.js" />
/// <reference path="assetmanagement/commoncontract.js" />
/// <reference path="assetmanagement/consumable.js" />
/// <reference path="assetmanagement/contractleaseorwarranty.js" />
/// <reference path="assetmanagement/contractsupportandmaintenance.js" />
/// <reference path="assetmanagement/hardwareasset.js" />
/// <reference path="assetmanagement/noticeevent.js" />
/// <reference path="assetmanagement/purchaselineitem.js" />
/// <reference path="assetmanagement/purchaseorder.js" />
/// <reference path="assetmanagement/softwareasset.js" />
/// <reference path="assetmanagement/subnet.js" />
/// <reference path="cultures/kendo.culture.af.min.js" />
/// <reference path="cultures/kendo.culture.af-za.min.js" />
/// <reference path="cultures/kendo.culture.am.min.js" />
/// <reference path="cultures/kendo.culture.am-et.min.js" />
/// <reference path="cultures/kendo.culture.ar.min.js" />
/// <reference path="cultures/kendo.culture.ar-ae.min.js" />
/// <reference path="cultures/kendo.culture.ar-bh.min.js" />
/// <reference path="cultures/kendo.culture.ar-dz.min.js" />
/// <reference path="cultures/kendo.culture.ar-eg.min.js" />
/// <reference path="cultures/kendo.culture.ar-iq.min.js" />
/// <reference path="cultures/kendo.culture.ar-jo.min.js" />
/// <reference path="cultures/kendo.culture.ar-kw.min.js" />
/// <reference path="cultures/kendo.culture.ar-lb.min.js" />
/// <reference path="cultures/kendo.culture.ar-ly.min.js" />
/// <reference path="cultures/kendo.culture.ar-ma.min.js" />
/// <reference path="cultures/kendo.culture.arn.min.js" />
/// <reference path="cultures/kendo.culture.arn-cl.min.js" />
/// <reference path="cultures/kendo.culture.ar-om.min.js" />
/// <reference path="cultures/kendo.culture.ar-qa.min.js" />
/// <reference path="cultures/kendo.culture.ar-sa.min.js" />
/// <reference path="cultures/kendo.culture.ar-sy.min.js" />
/// <reference path="cultures/kendo.culture.ar-tn.min.js" />
/// <reference path="cultures/kendo.culture.ar-ye.min.js" />
/// <reference path="cultures/kendo.culture.as.min.js" />
/// <reference path="cultures/kendo.culture.as-in.min.js" />
/// <reference path="cultures/kendo.culture.az.min.js" />
/// <reference path="cultures/kendo.culture.az-cyrl.min.js" />
/// <reference path="cultures/kendo.culture.az-cyrl-az.min.js" />
/// <reference path="cultures/kendo.culture.az-latn.min.js" />
/// <reference path="cultures/kendo.culture.az-latn-az.min.js" />
/// <reference path="cultures/kendo.culture.ba.min.js" />
/// <reference path="cultures/kendo.culture.ba-ru.min.js" />
/// <reference path="cultures/kendo.culture.be.min.js" />
/// <reference path="cultures/kendo.culture.be-by.min.js" />
/// <reference path="cultures/kendo.culture.bg.min.js" />
/// <reference path="cultures/kendo.culture.bg-bg.min.js" />
/// <reference path="cultures/kendo.culture.bn.min.js" />
/// <reference path="cultures/kendo.culture.bn-bd.min.js" />
/// <reference path="cultures/kendo.culture.bn-in.min.js" />
/// <reference path="cultures/kendo.culture.bo.min.js" />
/// <reference path="cultures/kendo.culture.bo-cn.min.js" />
/// <reference path="cultures/kendo.culture.br.min.js" />
/// <reference path="cultures/kendo.culture.br-fr.min.js" />
/// <reference path="cultures/kendo.culture.bs.min.js" />
/// <reference path="cultures/kendo.culture.bs-cyrl.min.js" />
/// <reference path="cultures/kendo.culture.bs-cyrl-ba.min.js" />
/// <reference path="cultures/kendo.culture.bs-latn.min.js" />
/// <reference path="cultures/kendo.culture.bs-latn-ba.min.js" />
/// <reference path="cultures/kendo.culture.ca.min.js" />
/// <reference path="cultures/kendo.culture.ca-es.min.js" />
/// <reference path="cultures/kendo.culture.co.min.js" />
/// <reference path="cultures/kendo.culture.co-fr.min.js" />
/// <reference path="cultures/kendo.culture.cs.min.js" />
/// <reference path="cultures/kendo.culture.cs-cz.min.js" />
/// <reference path="cultures/kendo.culture.cy.min.js" />
/// <reference path="cultures/kendo.culture.cy-gb.min.js" />
/// <reference path="cultures/kendo.culture.da.min.js" />
/// <reference path="cultures/kendo.culture.da-dk.min.js" />
/// <reference path="cultures/kendo.culture.de.min.js" />
/// <reference path="cultures/kendo.culture.de-at.min.js" />
/// <reference path="cultures/kendo.culture.de-ch.min.js" />
/// <reference path="cultures/kendo.culture.de-de.min.js" />
/// <reference path="cultures/kendo.culture.de-li.min.js" />
/// <reference path="cultures/kendo.culture.de-lu.min.js" />
/// <reference path="cultures/kendo.culture.dsb.min.js" />
/// <reference path="cultures/kendo.culture.dsb-de.min.js" />
/// <reference path="cultures/kendo.culture.dv.min.js" />
/// <reference path="cultures/kendo.culture.dv-mv.min.js" />
/// <reference path="cultures/kendo.culture.el.min.js" />
/// <reference path="cultures/kendo.culture.el-gr.min.js" />
/// <reference path="cultures/kendo.culture.en.min.js" />
/// <reference path="cultures/kendo.culture.en-029.min.js" />
/// <reference path="cultures/kendo.culture.en-au.min.js" />
/// <reference path="cultures/kendo.culture.en-bz.min.js" />
/// <reference path="cultures/kendo.culture.en-ca.min.js" />
/// <reference path="cultures/kendo.culture.en-gb.min.js" />
/// <reference path="cultures/kendo.culture.en-ie.min.js" />
/// <reference path="cultures/kendo.culture.en-in.min.js" />
/// <reference path="cultures/kendo.culture.en-jm.min.js" />
/// <reference path="cultures/kendo.culture.en-my.min.js" />
/// <reference path="cultures/kendo.culture.en-nz.min.js" />
/// <reference path="cultures/kendo.culture.en-ph.min.js" />
/// <reference path="cultures/kendo.culture.en-sg.min.js" />
/// <reference path="cultures/kendo.culture.en-tt.min.js" />
/// <reference path="cultures/kendo.culture.en-us.min.js" />
/// <reference path="cultures/kendo.culture.en-za.min.js" />
/// <reference path="cultures/kendo.culture.en-zw.min.js" />
/// <reference path="cultures/kendo.culture.es.min.js" />
/// <reference path="cultures/kendo.culture.es-ar.min.js" />
/// <reference path="cultures/kendo.culture.es-bo.min.js" />
/// <reference path="cultures/kendo.culture.es-cl.min.js" />
/// <reference path="cultures/kendo.culture.es-co.min.js" />
/// <reference path="cultures/kendo.culture.es-cr.min.js" />
/// <reference path="cultures/kendo.culture.es-do.min.js" />
/// <reference path="cultures/kendo.culture.es-ec.min.js" />
/// <reference path="cultures/kendo.culture.es-es.min.js" />
/// <reference path="cultures/kendo.culture.es-gt.min.js" />
/// <reference path="cultures/kendo.culture.es-hn.min.js" />
/// <reference path="cultures/kendo.culture.es-mx.min.js" />
/// <reference path="cultures/kendo.culture.es-ni.min.js" />
/// <reference path="cultures/kendo.culture.es-pa.min.js" />
/// <reference path="cultures/kendo.culture.es-pe.min.js" />
/// <reference path="cultures/kendo.culture.es-pr.min.js" />
/// <reference path="cultures/kendo.culture.es-py.min.js" />
/// <reference path="cultures/kendo.culture.es-sv.min.js" />
/// <reference path="cultures/kendo.culture.es-us.min.js" />
/// <reference path="cultures/kendo.culture.es-uy.min.js" />
/// <reference path="cultures/kendo.culture.es-ve.min.js" />
/// <reference path="cultures/kendo.culture.et.min.js" />
/// <reference path="cultures/kendo.culture.et-ee.min.js" />
/// <reference path="cultures/kendo.culture.eu.min.js" />
/// <reference path="cultures/kendo.culture.eu-es.min.js" />
/// <reference path="cultures/kendo.culture.fa.min.js" />
/// <reference path="cultures/kendo.culture.fa-ir.min.js" />
/// <reference path="cultures/kendo.culture.fi.min.js" />
/// <reference path="cultures/kendo.culture.fi-fi.min.js" />
/// <reference path="cultures/kendo.culture.fil.min.js" />
/// <reference path="cultures/kendo.culture.fil-ph.min.js" />
/// <reference path="cultures/kendo.culture.fo.min.js" />
/// <reference path="cultures/kendo.culture.fo-fo.min.js" />
/// <reference path="cultures/kendo.culture.fr.min.js" />
/// <reference path="cultures/kendo.culture.fr-be.min.js" />
/// <reference path="cultures/kendo.culture.fr-ca.min.js" />
/// <reference path="cultures/kendo.culture.fr-ch.min.js" />
/// <reference path="cultures/kendo.culture.fr-fr.min.js" />
/// <reference path="cultures/kendo.culture.fr-lu.min.js" />
/// <reference path="cultures/kendo.culture.fr-mc.min.js" />
/// <reference path="cultures/kendo.culture.fy.min.js" />
/// <reference path="cultures/kendo.culture.fy-nl.min.js" />
/// <reference path="cultures/kendo.culture.ga.min.js" />
/// <reference path="cultures/kendo.culture.ga-ie.min.js" />
/// <reference path="cultures/kendo.culture.gd.min.js" />
/// <reference path="cultures/kendo.culture.gd-gb.min.js" />
/// <reference path="cultures/kendo.culture.gl.min.js" />
/// <reference path="cultures/kendo.culture.gl-es.min.js" />
/// <reference path="cultures/kendo.culture.gsw.min.js" />
/// <reference path="cultures/kendo.culture.gsw-fr.min.js" />
/// <reference path="cultures/kendo.culture.gu.min.js" />
/// <reference path="cultures/kendo.culture.gu-in.min.js" />
/// <reference path="cultures/kendo.culture.ha.min.js" />
/// <reference path="cultures/kendo.culture.ha-latn.min.js" />
/// <reference path="cultures/kendo.culture.ha-latn-ng.min.js" />
/// <reference path="cultures/kendo.culture.he.min.js" />
/// <reference path="cultures/kendo.culture.he-il.min.js" />
/// <reference path="cultures/kendo.culture.hi.min.js" />
/// <reference path="cultures/kendo.culture.hi-in.min.js" />
/// <reference path="cultures/kendo.culture.hr.min.js" />
/// <reference path="cultures/kendo.culture.hr-ba.min.js" />
/// <reference path="cultures/kendo.culture.hr-hr.min.js" />
/// <reference path="cultures/kendo.culture.hsb.min.js" />
/// <reference path="cultures/kendo.culture.hsb-de.min.js" />
/// <reference path="cultures/kendo.culture.hu.min.js" />
/// <reference path="cultures/kendo.culture.hu-hu.min.js" />
/// <reference path="cultures/kendo.culture.hy.min.js" />
/// <reference path="cultures/kendo.culture.hy-am.min.js" />
/// <reference path="cultures/kendo.culture.id.min.js" />
/// <reference path="cultures/kendo.culture.id-id.min.js" />
/// <reference path="cultures/kendo.culture.ig.min.js" />
/// <reference path="cultures/kendo.culture.ig-ng.min.js" />
/// <reference path="cultures/kendo.culture.ii.min.js" />
/// <reference path="cultures/kendo.culture.ii-cn.min.js" />
/// <reference path="cultures/kendo.culture.is.min.js" />
/// <reference path="cultures/kendo.culture.is-is.min.js" />
/// <reference path="cultures/kendo.culture.it.min.js" />
/// <reference path="cultures/kendo.culture.it-ch.min.js" />
/// <reference path="cultures/kendo.culture.it-it.min.js" />
/// <reference path="cultures/kendo.culture.iu.min.js" />
/// <reference path="cultures/kendo.culture.iu-cans.min.js" />
/// <reference path="cultures/kendo.culture.iu-cans-ca.min.js" />
/// <reference path="cultures/kendo.culture.iu-latn.min.js" />
/// <reference path="cultures/kendo.culture.iu-latn-ca.min.js" />
/// <reference path="cultures/kendo.culture.ja.min.js" />
/// <reference path="cultures/kendo.culture.ja-jp.min.js" />
/// <reference path="cultures/kendo.culture.ka.min.js" />
/// <reference path="cultures/kendo.culture.ka-ge.min.js" />
/// <reference path="cultures/kendo.culture.kk.min.js" />
/// <reference path="cultures/kendo.culture.kk-kz.min.js" />
/// <reference path="cultures/kendo.culture.kl.min.js" />
/// <reference path="cultures/kendo.culture.kl-gl.min.js" />
/// <reference path="cultures/kendo.culture.km.min.js" />
/// <reference path="cultures/kendo.culture.km-kh.min.js" />
/// <reference path="cultures/kendo.culture.kn.min.js" />
/// <reference path="cultures/kendo.culture.kn-in.min.js" />
/// <reference path="cultures/kendo.culture.ko.min.js" />
/// <reference path="cultures/kendo.culture.kok.min.js" />
/// <reference path="cultures/kendo.culture.kok-in.min.js" />
/// <reference path="cultures/kendo.culture.ko-kr.min.js" />
/// <reference path="cultures/kendo.culture.ky.min.js" />
/// <reference path="cultures/kendo.culture.ky-kg.min.js" />
/// <reference path="cultures/kendo.culture.lb.min.js" />
/// <reference path="cultures/kendo.culture.lb-lu.min.js" />
/// <reference path="cultures/kendo.culture.lo.min.js" />
/// <reference path="cultures/kendo.culture.lo-la.min.js" />
/// <reference path="cultures/kendo.culture.lt.min.js" />
/// <reference path="cultures/kendo.culture.lt-lt.min.js" />
/// <reference path="cultures/kendo.culture.lv.min.js" />
/// <reference path="cultures/kendo.culture.lv-lv.min.js" />
/// <reference path="cultures/kendo.culture.mi.min.js" />
/// <reference path="cultures/kendo.culture.mi-nz.min.js" />
/// <reference path="cultures/kendo.culture.mk.min.js" />
/// <reference path="cultures/kendo.culture.mk-mk.min.js" />
/// <reference path="cultures/kendo.culture.ml.min.js" />
/// <reference path="cultures/kendo.culture.ml-in.min.js" />
/// <reference path="cultures/kendo.culture.mn.min.js" />
/// <reference path="cultures/kendo.culture.mn-cyrl.min.js" />
/// <reference path="cultures/kendo.culture.mn-mn.min.js" />
/// <reference path="cultures/kendo.culture.mn-mong.min.js" />
/// <reference path="cultures/kendo.culture.mn-mong-cn.min.js" />
/// <reference path="cultures/kendo.culture.moh.min.js" />
/// <reference path="cultures/kendo.culture.moh-ca.min.js" />
/// <reference path="cultures/kendo.culture.mr.min.js" />
/// <reference path="cultures/kendo.culture.mr-in.min.js" />
/// <reference path="cultures/kendo.culture.ms.min.js" />
/// <reference path="cultures/kendo.culture.ms-bn.min.js" />
/// <reference path="cultures/kendo.culture.ms-my.min.js" />
/// <reference path="cultures/kendo.culture.mt.min.js" />
/// <reference path="cultures/kendo.culture.mt-mt.min.js" />
/// <reference path="cultures/kendo.culture.nb.min.js" />
/// <reference path="cultures/kendo.culture.nb-no.min.js" />
/// <reference path="cultures/kendo.culture.ne.min.js" />
/// <reference path="cultures/kendo.culture.ne-np.min.js" />
/// <reference path="cultures/kendo.culture.nl.min.js" />
/// <reference path="cultures/kendo.culture.nl-be.min.js" />
/// <reference path="cultures/kendo.culture.nl-nl.min.js" />
/// <reference path="cultures/kendo.culture.nn.min.js" />
/// <reference path="cultures/kendo.culture.nn-no.min.js" />
/// <reference path="cultures/kendo.culture.no.min.js" />
/// <reference path="cultures/kendo.culture.nso.min.js" />
/// <reference path="cultures/kendo.culture.nso-za.min.js" />
/// <reference path="cultures/kendo.culture.oc.min.js" />
/// <reference path="cultures/kendo.culture.oc-fr.min.js" />
/// <reference path="cultures/kendo.culture.or.min.js" />
/// <reference path="cultures/kendo.culture.or-in.min.js" />
/// <reference path="cultures/kendo.culture.pa.min.js" />
/// <reference path="cultures/kendo.culture.pa-in.min.js" />
/// <reference path="cultures/kendo.culture.pl.min.js" />
/// <reference path="cultures/kendo.culture.pl-pl.min.js" />
/// <reference path="cultures/kendo.culture.prs.min.js" />
/// <reference path="cultures/kendo.culture.prs-af.min.js" />
/// <reference path="cultures/kendo.culture.ps.min.js" />
/// <reference path="cultures/kendo.culture.ps-af.min.js" />
/// <reference path="cultures/kendo.culture.pt.min.js" />
/// <reference path="cultures/kendo.culture.pt-br.min.js" />
/// <reference path="cultures/kendo.culture.pt-pt.min.js" />
/// <reference path="cultures/kendo.culture.qut.min.js" />
/// <reference path="cultures/kendo.culture.qut-gt.min.js" />
/// <reference path="cultures/kendo.culture.quz.min.js" />
/// <reference path="cultures/kendo.culture.quz-bo.min.js" />
/// <reference path="cultures/kendo.culture.quz-ec.min.js" />
/// <reference path="cultures/kendo.culture.quz-pe.min.js" />
/// <reference path="cultures/kendo.culture.rm.min.js" />
/// <reference path="cultures/kendo.culture.rm-ch.min.js" />
/// <reference path="cultures/kendo.culture.ro.min.js" />
/// <reference path="cultures/kendo.culture.ro-ro.min.js" />
/// <reference path="cultures/kendo.culture.ru.min.js" />
/// <reference path="cultures/kendo.culture.ru-ru.min.js" />
/// <reference path="cultures/kendo.culture.ru-ua.min.js" />
/// <reference path="cultures/kendo.culture.rw.min.js" />
/// <reference path="cultures/kendo.culture.rw-rw.min.js" />
/// <reference path="cultures/kendo.culture.sa.min.js" />
/// <reference path="cultures/kendo.culture.sah.min.js" />
/// <reference path="cultures/kendo.culture.sah-ru.min.js" />
/// <reference path="cultures/kendo.culture.sa-in.min.js" />
/// <reference path="cultures/kendo.culture.se.min.js" />
/// <reference path="cultures/kendo.culture.se-fi.min.js" />
/// <reference path="cultures/kendo.culture.se-no.min.js" />
/// <reference path="cultures/kendo.culture.se-se.min.js" />
/// <reference path="cultures/kendo.culture.si.min.js" />
/// <reference path="cultures/kendo.culture.si-lk.min.js" />
/// <reference path="cultures/kendo.culture.sk.min.js" />
/// <reference path="cultures/kendo.culture.sk-sk.min.js" />
/// <reference path="cultures/kendo.culture.sl.min.js" />
/// <reference path="cultures/kendo.culture.sl-si.min.js" />
/// <reference path="cultures/kendo.culture.sma.min.js" />
/// <reference path="cultures/kendo.culture.sma-no.min.js" />
/// <reference path="cultures/kendo.culture.sma-se.min.js" />
/// <reference path="cultures/kendo.culture.smj.min.js" />
/// <reference path="cultures/kendo.culture.smj-no.min.js" />
/// <reference path="cultures/kendo.culture.smj-se.min.js" />
/// <reference path="cultures/kendo.culture.smn.min.js" />
/// <reference path="cultures/kendo.culture.smn-fi.min.js" />
/// <reference path="cultures/kendo.culture.sms.min.js" />
/// <reference path="cultures/kendo.culture.sms-fi.min.js" />
/// <reference path="cultures/kendo.culture.sq.min.js" />
/// <reference path="cultures/kendo.culture.sq-al.min.js" />
/// <reference path="cultures/kendo.culture.sr.min.js" />
/// <reference path="cultures/kendo.culture.sr-cyrl.min.js" />
/// <reference path="cultures/kendo.culture.sr-cyrl-ba.min.js" />
/// <reference path="cultures/kendo.culture.sr-cyrl-cs.min.js" />
/// <reference path="cultures/kendo.culture.sr-cyrl-me.min.js" />
/// <reference path="cultures/kendo.culture.sr-cyrl-rs.min.js" />
/// <reference path="cultures/kendo.culture.sr-latn.min.js" />
/// <reference path="cultures/kendo.culture.sr-latn-ba.min.js" />
/// <reference path="cultures/kendo.culture.sr-latn-cs.min.js" />
/// <reference path="cultures/kendo.culture.sr-latn-me.min.js" />
/// <reference path="cultures/kendo.culture.sr-latn-rs.min.js" />
/// <reference path="cultures/kendo.culture.sv.min.js" />
/// <reference path="cultures/kendo.culture.sv-fi.min.js" />
/// <reference path="cultures/kendo.culture.sv-se.min.js" />
/// <reference path="cultures/kendo.culture.sw.min.js" />
/// <reference path="cultures/kendo.culture.sw-ke.min.js" />
/// <reference path="cultures/kendo.culture.syr.min.js" />
/// <reference path="cultures/kendo.culture.syr-sy.min.js" />
/// <reference path="cultures/kendo.culture.ta.min.js" />
/// <reference path="cultures/kendo.culture.ta-in.min.js" />
/// <reference path="cultures/kendo.culture.te.min.js" />
/// <reference path="cultures/kendo.culture.te-in.min.js" />
/// <reference path="cultures/kendo.culture.tg.min.js" />
/// <reference path="cultures/kendo.culture.tg-cyrl.min.js" />
/// <reference path="cultures/kendo.culture.tg-cyrl-tj.min.js" />
/// <reference path="cultures/kendo.culture.th.min.js" />
/// <reference path="cultures/kendo.culture.th-th.min.js" />
/// <reference path="cultures/kendo.culture.tk.min.js" />
/// <reference path="cultures/kendo.culture.tk-tm.min.js" />
/// <reference path="cultures/kendo.culture.tn.min.js" />
/// <reference path="cultures/kendo.culture.tn-za.min.js" />
/// <reference path="cultures/kendo.culture.tr.min.js" />
/// <reference path="cultures/kendo.culture.tr-tr.min.js" />
/// <reference path="cultures/kendo.culture.tt.min.js" />
/// <reference path="cultures/kendo.culture.tt-ru.min.js" />
/// <reference path="cultures/kendo.culture.tzm.min.js" />
/// <reference path="cultures/kendo.culture.tzm-latn.min.js" />
/// <reference path="cultures/kendo.culture.tzm-latn-dz.min.js" />
/// <reference path="cultures/kendo.culture.ug.min.js" />
/// <reference path="cultures/kendo.culture.ug-cn.min.js" />
/// <reference path="cultures/kendo.culture.uk.min.js" />
/// <reference path="cultures/kendo.culture.uk-ua.min.js" />
/// <reference path="cultures/kendo.culture.ur.min.js" />
/// <reference path="cultures/kendo.culture.ur-pk.min.js" />
/// <reference path="cultures/kendo.culture.uz.min.js" />
/// <reference path="cultures/kendo.culture.uz-cyrl.min.js" />
/// <reference path="cultures/kendo.culture.uz-cyrl-uz.min.js" />
/// <reference path="cultures/kendo.culture.uz-latn.min.js" />
/// <reference path="cultures/kendo.culture.uz-latn-uz.min.js" />
/// <reference path="cultures/kendo.culture.vi.min.js" />
/// <reference path="cultures/kendo.culture.vi-vn.min.js" />
/// <reference path="cultures/kendo.culture.wo.min.js" />
/// <reference path="cultures/kendo.culture.wo-sn.min.js" />
/// <reference path="cultures/kendo.culture.xh.min.js" />
/// <reference path="cultures/kendo.culture.xh-za.min.js" />
/// <reference path="cultures/kendo.culture.yo.min.js" />
/// <reference path="cultures/kendo.culture.yo-ng.min.js" />
/// <reference path="cultures/kendo.culture.zh.min.js" />
/// <reference path="cultures/kendo.culture.zh-chs.min.js" />
/// <reference path="cultures/kendo.culture.zh-cht.min.js" />
/// <reference path="cultures/kendo.culture.zh-cn.min.js" />
/// <reference path="cultures/kendo.culture.zh-hans.min.js" />
/// <reference path="cultures/kendo.culture.zh-hant.min.js" />
/// <reference path="cultures/kendo.culture.zh-hk.min.js" />
/// <reference path="cultures/kendo.culture.zh-mo.min.js" />
/// <reference path="cultures/kendo.culture.zh-sg.min.js" />
/// <reference path="cultures/kendo.culture.zh-tw.min.js" />
/// <reference path="cultures/kendo.culture.zu.min.js" />
/// <reference path="cultures/kendo.culture.zu-za.min.js" />
/// <reference path="drawerbuilder.js" />
/// <reference path="forms/adminmain.js" />
/// <reference path="forms/ammain.js" />
/// <reference path="forms/enumsettingsmain.js" />
/// <reference path="forms/fields/boolean/controller.js" />
/// <reference path="forms/fields/bundle/controller.js" />
/// <reference path="forms/fields/button/controller.js" />
/// <reference path="forms/fields/combo/controller.js" />
/// <reference path="forms/fields/date/controller.js" />
/// <reference path="forms/fields/datetime/controller.js" />
/// <reference path="forms/fields/decimal/controller.js" />
/// <reference path="forms/fields/display/controller.js" />
/// <reference path="forms/fields/double/controller.js" />
/// <reference path="forms/fields/dropdownlist/controller.js" />
/// <reference path="forms/fields/editor/controller.js" />
/// <reference path="forms/fields/enum/controller.js" />
/// <reference path="forms/fields/enum2/controller.js" />
/// <reference path="forms/fields/fileupload/controller.js" />
/// <reference path="forms/fields/int/controller.js" />
/// <reference path="forms/fields/longstring/controller.js" />
/// <reference path="forms/fields/numeric/controller.js" />
/// <reference path="forms/fields/objectpicker/controller.js" />
/// <reference path="forms/fields/percentage/controller.js" />
/// <reference path="forms/fields/spacer/controller.js" />
/// <reference path="forms/fields/string/controller.js" />
/// <reference path="forms/fields/urltextbox/controller.js" />
/// <reference path="forms/fields/userpicker/controller.js" />
/// <reference path="forms/flyout/fileattachmentsflyout/controller.js" />
/// <reference path="forms/form.js" />
/// <reference path="forms/formbuilder.js" />
/// <reference path="forms/formhelper.js" />
/// <reference path="forms/header/approval/controller.js" />
/// <reference path="forms/header/relationships/controller.js" />
/// <reference path="forms/header/slo/controller.js" />
/// <reference path="forms/header/spacer/controller.js" />
/// <reference path="forms/header/status/controller.js" />
/// <reference path="forms/header/title/controller.js" />
/// <reference path="forms/headerbuilder.js" />
/// <reference path="forms/kbmain.js" />
/// <reference path="forms/popups/multipleobjectpickerpopup/controller.js" />
/// <reference path="forms/popups/objectpickerpopup/controller.js" />
/// <reference path="forms/popups/userpickerpopup/controller.js" />
/// <reference path="forms/predefined/actionlog/controller.js" />
/// <reference path="forms/predefined/activities/controller.js" />
/// <reference path="forms/predefined/affecteditems/controller.js" />
/// <reference path="forms/predefined/billabletime/controller.js" />
/// <reference path="forms/predefined/childworkitems/controller.js" />
/// <reference path="forms/predefined/fileattachments/controller.js" />
/// <reference path="forms/predefined/fileattachmentsdragdrop/controller.js" />
/// <reference path="forms/predefined/history/controller.js" />
/// <reference path="forms/predefined/knowledgearticle/controller.js" />
/// <reference path="forms/predefined/multipleobjectpicker/controller.js" />
/// <reference path="forms/predefined/relateditems/controller.js" />
/// <reference path="forms/predefined/userinput/controller.js" />
/// <reference path="forms/profilemain.js" />
/// <reference path="forms/structure/columnfield/controller.js" />
/// <reference path="forms/structure/customfieldgroup/controller.js" />
/// <reference path="forms/structure/customfieldgrouprow/controller.js" />
/// <reference path="forms/structure/formpanel/controller.js" />
/// <reference path="forms/structure/formpanelfull/controller.js" />
/// <reference path="forms/structure/tab/controller.js" />
/// <reference path="forms/structure/tabdata/controller.js" />
/// <reference path="forms/structure/tabnavigation/controller.js" />
/// <reference path="forms/structure/tabpane/controller.js" />
/// <reference path="forms/taskbuilder.js" />
/// <reference path="forms/tasks/acknowledge/controller.js" />
/// <reference path="forms/tasks/addMeToWatchList/controller.js" />
/// <reference path="forms/tasks/amchangestatus/controller.js" />
/// <reference path="forms/tasks/analystbygroup/controller.js" />
/// <reference path="forms/tasks/anchor/controller.js" />
/// <reference path="forms/tasks/assigntome/controller.js" />
/// <reference path="forms/tasks/associateitem/controller.js" />
/// <reference path="forms/tasks/changestatus/controller.js" />
/// <reference path="forms/tasks/converttoparent/controller.js" />
/// <reference path="forms/tasks/copylicenseassignments/controller.js" />
/// <reference path="forms/tasks/copytonewwi/controller.js" />
/// <reference path="forms/tasks/custom/controller.js" />
/// <reference path="forms/tasks/decreaseavailablecount/controller.js" />
/// <reference path="forms/tasks/increaseavailablecount/controller.js" />
/// <reference path="forms/tasks/linktoparent/controller.js" />
/// <reference path="forms/tasks/newstatus/controller.js" />
/// <reference path="forms/tasks/print/controller.js" />
/// <reference path="forms/tasks/sendemail/controller.js" />
/// <reference path="forms/tasks/setdate/controller.js" />
/// <reference path="forms/tasks/spacer/controller.js" />
/// <reference path="forms/tasks/updateassetmanagement/controller.js" />
/// <reference path="forms/tasks/updatesupersededhardware/controller.js" />
/// <reference path="forms/templates/amcontractlease.js" />
/// <reference path="forms/templates/amcontractsupportandmaintenance.js" />
/// <reference path="forms/templates/amcontractwarranty.js" />
/// <reference path="forms/templates/announcement.js" />
/// <reference path="forms/templates/catalogitem.js" />
/// <reference path="forms/templates/changerequest.js" />
/// <reference path="forms/templates/consumables.js" />
/// <reference path="forms/templates/costcenter.js" />
/// <reference path="forms/templates/hardwareasset.js" />
/// <reference path="forms/templates/incident.js" />
/// <reference path="forms/templates/invoice.js" />
/// <reference path="forms/templates/knowledgebase.js" />
/// <reference path="forms/templates/license.js" />
/// <reference path="forms/templates/location.js" />
/// <reference path="forms/templates/newnoticeevent.js" />
/// <reference path="forms/templates/organization.js" />
/// <reference path="forms/templates/problem.js" />
/// <reference path="forms/templates/purchase.js" />
/// <reference path="forms/templates/purchaseorder.js" />
/// <reference path="forms/templates/relateduserinfo.js" />
/// <reference path="forms/templates/releaserecord.js" />
/// <reference path="forms/templates/servicerequest.js" />
/// <reference path="forms/templates/softwareasset.js" />
/// <reference path="forms/templates/standard.js" />
/// <reference path="forms/templates/subnet.js" />
/// <reference path="forms/templates/userprofile.js" />
/// <reference path="forms/templates/vendor.js" />
/// <reference path="forms/wiactivitymain.js" />
/// <reference path="forms/wimain.js" />
/// <reference path="grids/columntemplates/anchor/controller.js" />
/// <reference path="grids/columntemplates/bool/controller.js" />
/// <reference path="grids/columntemplates/columnbase/controller.js" />
/// <reference path="grids/columntemplates/command/controller.js" />
/// <reference path="grids/columntemplates/date/controller.js" />
/// <reference path="grids/columntemplates/input/controller.js" />
/// <reference path="grids/columntemplates/number/controller.js" />
/// <reference path="grids/columntemplates/slostatus/controller.js" />
/// <reference path="grids/columntemplates/string/controller.js" />
/// <reference path="grids/gridbuilder.js" />
/// <reference path="grids/gridmain.js" />
/// <reference path="grids/mobile/controller.js" />
/// <reference path="grids/structure/datasource/controller.js" />
/// <reference path="grids/structure/defaultconfiguration/controller.js" />
/// <reference path="grids/structure/drawer/controller.js" />
/// <reference path="grids/structure/events/controller.js" />
/// <reference path="grids/structure/sourcefields/controller.js" />
/// <reference path="grids/structure/toolbar/controller.js" />
/// <reference path="grids/templates/searchworkitems.js" />
/// <reference path="jquery-1.10.2.js" />
/// <reference path="jquery-2.1.0.js" />
/// <reference path="kendo/2018.1.117/angular.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.aa.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.aa-DJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.aa-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.aa-ET.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.af.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.af-NA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.af-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.agq.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.agq-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ak.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ak-GH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.am.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.am-ET.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-AE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-BH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-DJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-DZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-EG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-IL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-IQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-JO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-KM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-KW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-LB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-LY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-MR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.arn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.arn-CL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-OM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-PS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-QA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-SA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-SD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-SO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-SS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-SY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-TD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-TN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ar-YE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.as.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.asa.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.asa-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.as-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ast.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ast-ES.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.az.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.az-Cyrl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.az-Cyrl-AZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.az-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.az-Latn-AZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ba.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ba-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bas.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bas-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.be.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.be-BY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bem.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bem-ZM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bez.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bez-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bg-BG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bin.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bin-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bm.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bm-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bm-Latn-ML.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bn-BD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bn-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bo-CN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bo-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.br.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.br-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.brx.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.brx-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bs.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bs-Cyrl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bs-Cyrl-BA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bs-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.bs-Latn-BA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.byn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.byn-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ca.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ca-AD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ca-ES.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ca-ES-valencia.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ca-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ca-IT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ce.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ce-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cgg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cgg-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.chr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.chr-Cher.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.chr-Cher-US.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.co.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.co-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cs.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cs-CZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cu-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cy.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.cy-GB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.da.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.da-DK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.da-GL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dav.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dav-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de-AT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de-BE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de-DE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de-LI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.de-LU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dje.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dje-NE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dsb.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dsb-DE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dua.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dua-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dv.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dv-MV.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dyo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dyo-SN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dz.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.dz-BT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ebu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ebu-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ee.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ee-GH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ee-TG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.el.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.el-CY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.el-GR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-029.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-150.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-AG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-AI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-AS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-AT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-AU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-BZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CX.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-CY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-DE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-DK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-DM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-FI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-FJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-FK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-FM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-GY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-HK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-ID.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-IE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-IL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-IM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-IO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-JE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-JM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-KI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-KN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-KY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-LC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-LR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-LS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MP.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-MY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-NZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-PG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-PH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-PK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-PN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-PR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-PW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-RW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SX.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-SZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-TC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-TK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-TO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-TT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-TV.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-UM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-US.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-VC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-VG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-VI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-VU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-WS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-ZM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.en-ZW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.eo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.eo-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-419.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-AR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-BO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-CL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-CO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-CR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-CU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-DO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-EC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-ES.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-GQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-GT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-HN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-MX.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-NI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-PA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-PE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-PH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-PR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-PY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-SV.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-US.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-UY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.es-VE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.et.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.et-EE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.eu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.eu-ES.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ewo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ewo-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fa.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fa-IR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff-GN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff-Latn-SN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff-MR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ff-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fi.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fi-FI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fil.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fil-PH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fo-DK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fo-FO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-029.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-BE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-BF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-BI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-BJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-BL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-DJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-DZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-GA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-GF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-GN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-GP.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-GQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-HT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-KM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-LU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-ML.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-MU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-NC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-NE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-PF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-PM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-RE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-RW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-SC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-SN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-SY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-TD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-TG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-TN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-VU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-WF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fr-YT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fur.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fur-IT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fy.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.fy-NL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ga.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ga-IE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gd.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gd-GB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gl-ES.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gn-PY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gsw.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gsw-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gsw-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gsw-LI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gu-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.guz.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.guz-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gv.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.gv-IM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ha.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ha-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ha-Latn-GH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ha-Latn-NE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ha-Latn-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.haw.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.haw-US.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.he.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.he-IL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hi.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hi-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hr-BA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hr-HR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hsb.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hsb-DE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hu-HU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hy.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.hy-AM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ia.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ia-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ia-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ibb.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ibb-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.id.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.id-ID.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ig.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ig-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ii.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ii-CN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.is.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.is-IS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.it.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.it-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.it-IT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.it-SM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.iu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.iu-Cans.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.iu-Cans-CA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.iu-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.iu-Latn-CA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ja.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ja-JP.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jgo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jgo-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jmc.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jmc-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jv.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jv-Java.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jv-Java-ID.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jv-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.jv-Latn-ID.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ka.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kab-DZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ka-GE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kam.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kam-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kde.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kde-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kea.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kea-CV.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.khq.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.khq-ML.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ki.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ki-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kk.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kkj.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kkj-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kk-KZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kl-GL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kln.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kln-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.km.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.km-KH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kn-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ko.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kok.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kok-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ko-KP.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ko-KR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kr-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ks.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ks-Arab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ks-Arab-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ksb.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ksb-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ks-Deva.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ks-Deva-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ksf.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ksf-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ksh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ksh-DE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ku.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ku-Arab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ku-Arab-IQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ku-Arab-IR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kw.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.kw-GB.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ky.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ky-KG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.la.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.la-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lag.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lag-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lb.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lb-LU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lg-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lkt.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lkt-US.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ln.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ln-AO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ln-CD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ln-CF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ln-CG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lo-LA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lrc.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lrc-IQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lrc-IR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lt.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lt-LT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lu-CD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.luo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.luo-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.luy.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.luy-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lv.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.lv-LV.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mas.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mas-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mas-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mer.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mer-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mfe.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mfe-MU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mgh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mgh-MZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mg-MG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mgo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mgo-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mi.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mi-NZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mk.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mk-MK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ml.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ml-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mn-Cyrl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mni.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mni-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mn-MN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mn-Mong.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mn-Mong-CN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mn-Mong-MN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.moh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.moh-CA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mr-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ms.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ms-BN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ms-MY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ms-SG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mt.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mt-MT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mua.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mua-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.my.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.my-MM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mzn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.mzn-IR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.naq.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.naq-NA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nb.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nb-NO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nb-SJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nd.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nd-ZW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ne.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ne-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ne-NP.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-AW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-BE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-BQ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-CW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-NL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-SR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nl-SX.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nmg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nmg-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nnh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nnh-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nn-NO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.no.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nqo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nqo-GN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nr-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nso.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nso-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nus.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nus-SS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nyn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.nyn-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.oc.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.oc-FR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.om.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.om-ET.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.om-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.or.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.or-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.os.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.os-GE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.os-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pa.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pa-Arab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pa-Arab-PK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pa-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pap.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pap-029.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pl-PL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.prg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.prg-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.prs.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.prs-AF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ps.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ps-AF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-AO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-BR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-CV.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-GW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-MO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-MZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-PT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-ST.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.pt-TL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quc.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quc-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quc-Latn-GT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quz.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quz-BO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quz-EC.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.quz-PE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rm.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rm-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rn-BI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ro.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rof.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rof-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ro-MD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ro-RO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru-BY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru-KG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru-KZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru-MD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ru-UA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rw.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rwk.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rwk-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.rw-RW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sa.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sah.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sah-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sa-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.saq.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.saq-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sbp.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sbp-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sd.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sd-Arab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sd-Arab-PK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sd-Deva.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sd-Deva-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.se.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.se-FI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.seh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.seh-MZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.se-NO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ses.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.se-SE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ses-ML.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sg-CF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.shi.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.shi-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.shi-Latn-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.shi-Tfng.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.shi-Tfng-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.si.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.si-LK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sk.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sk-SK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sl-SI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sma.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sma-NO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sma-SE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.smj.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.smj-NO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.smj-SE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.smn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.smn-FI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sms.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sms-FI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sn-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sn-Latn-ZW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.so.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.so-DJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.so-ET.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.so-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.so-SO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sq.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sq-AL.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sq-MK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sq-XK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Cyrl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Cyrl-BA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Cyrl-ME.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Cyrl-RS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Cyrl-XK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Latn-BA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Latn-ME.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Latn-RS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sr-Latn-XK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ss.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ss-SZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ssy.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ssy-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ss-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.st.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.st-LS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.st-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sv.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sv-AX.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sv-FI.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sv-SE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sw.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sw-CD.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sw-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sw-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.sw-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.syr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.syr-SY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ta.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ta-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ta-LK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ta-MY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ta-SG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.te.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.te-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.teo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.teo-KE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.teo-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tg.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tg-Cyrl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tg-Cyrl-TJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.th.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.th-TH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ti.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ti-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ti-ET.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tig.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tig-ER.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tk.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tk-TM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tn-BW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tn-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.to.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.to-TO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tr.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tr-CY.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tr-TR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ts.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ts-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tt.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tt-RU.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.twq.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.twq-NE.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Arab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Arab-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Latn-DZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Latn-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Tfng.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.tzm-Tfng-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ug.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ug-CN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uk.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uk-UA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ur.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ur-IN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ur-PK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz-Arab.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz-Arab-AF.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz-Cyrl.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz-Cyrl-UZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.uz-Latn-UZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vai.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vai-Latn.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vai-Latn-LR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vai-Vaii.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vai-Vaii-LR.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ve.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.ve-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vi.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vi-VN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vo-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vun.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.vun-TZ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.wae.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.wae-CH.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.wal.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.wal-ET.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.wo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.wo-SN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.xh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.xh-ZA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.xog.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.xog-UG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yav.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yav-CM.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yi.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yi-001.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yo.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yo-BJ.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.yo-NG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zgh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zgh-Tfng.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zgh-Tfng-MA.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-CHS.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-CHT.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-CN.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-Hans.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-Hans-HK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-Hans-MO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-Hant.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-HK.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-MO.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-SG.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zh-TW.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zu.min.js" />
/// <reference path="kendo/2018.1.117/cultures/kendo.culture.zu-ZA.min.js" />
/// <reference path="kendo/2018.1.117/jquery.min.js" />
/// <reference path="kendo/2018.1.117/jszip.min.js" />
/// <reference path="kendo/2018.1.117/kendo.all.min.js" />
/// <reference path="kendo/2018.1.117/kendo.angular.min.js" />
/// <reference path="kendo/2018.1.117/kendo.aspnetmvc.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.bg-BG.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.cs-CZ.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.da-DK.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.de-AT.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.de-CH.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.de-DE.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.de-LI.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.el-GR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.en-AU.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.en-CA.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.en-GB.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.en-US.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-AR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-BO.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-CL.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-CO.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-CR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-DO.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-EC.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-ES.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-GT.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-HN.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-MX.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-NI.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-PA.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-PE.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-PR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-PY.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-US.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-UY.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.es-VE.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fa-IR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fi-FI.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-BE.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-CA.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-CD.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-CH.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-CI.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-CM.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-FR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-HT.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-LU.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-MA.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-MC.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-ML.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.fr-SN.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.he-IL.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.hu-HU.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.hy-AM.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.it-CH.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.it-IT.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.ja-JP.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.nb-NO.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.nl-BE.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.nl-NL.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.pl-PL.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.pt-BR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.pt-PT.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.ro-RO.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.ru-RU.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.sk-SK.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.sv-SE.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.tr-TR.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.uk-UA.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.zh-CN.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.zh-HK.min.js" />
/// <reference path="kendo/2018.1.117/messages/kendo.messages.zh-TW.min.js" />
/// <reference path="kendo/kendo.modernizr.custom.js" />
/// <reference path="kendo/kendo.web.ext.js" />
/// <reference path="kendo/kendoui.pageeditor/kendo.all.min.js" />
/// <reference path="libs/angular/adf-structures-base.js" />
/// <reference path="libs/angular/angular.1.4.7.js" />
/// <reference path="libs/angular/angular.js" />
/// <reference path="libs/angular/angularamd.js" />
/// <reference path="libs/angular/angular-animate.min.js" />
/// <reference path="libs/angular/angular-aria.js" />
/// <reference path="libs/angular/angular-aside.js" />
/// <reference path="libs/angular/angular-dashboard-framework.js" />
/// <reference path="libs/angular/angular-material.js" />
/// <reference path="libs/angular/angular-messages.js" />
/// <reference path="libs/angular/angular-resource.js" />
/// <reference path="libs/angular/angular-route.js" />
/// <reference path="libs/angular/angular-sanitize.js" />
/// <reference path="libs/angular/angular-ui-router.js" />
/// <reference path="libs/angular/ng-infinite-scroll.js" />
/// <reference path="libs/angular/ui-bootstrap.0.14.3.js" />
/// <reference path="libs/angular/ui-bootstrap.js" />
/// <reference path="libs/angular/ui-bootstrap-tpls.js" />
/// <reference path="libs/angular/ui-bootstrap-tpls-1.3.3.min.js" />
/// <reference path="libs/bootstrap.js" />
/// <reference path="libs/highlight.min.js" />
/// <reference path="libs/jquery.atwho.js" />
/// <reference path="libs/jquery.caret.js" />
/// <reference path="libs/jquery.easing.1.3.min.js" />
/// <reference path="libs/moment_locales.min.js" />
/// <reference path="libs/pagetitlenotification.min.js" />
/// <reference path="libs/perfect-scrollbar-0.4.8.with-mousewheel.min.js" />
/// <reference path="libs/sortable.js" />
/// <reference path="libs/store2.js" />
/// <reference path="libs/underscore.js" />
/// <reference path="ng/app.js" />
/// <reference path="ng/kb/home/app.js" />
/// <reference path="ng/kb/kbfactory.js" />
/// <reference path="ng/kb/listing/app.js" />
/// <reference path="ng/kb/listing/kbListingController.js" />
/// <reference path="ng/kb/listing/kbListingMain.js" />
/// <reference path="ng/kb/view/app.js" />
/// <reference path="ng/kb/view/kbViewController.js" />
/// <reference path="ng/kb/view/kbViewMain.js" />
/// <reference path="ng/page/adfWidgets/advancedChart/advanced.chart.config.service.js" />
/// <reference path="ng/page/adfWidgets/advancedChart/chart/adf-widget-advanced-chart.js" />
/// <reference path="ng/page/adfWidgets/advancedChart/configFiles/advancedChartConfig.js" />
/// <reference path="ng/page/adfWidgets/advancedCount/adf-widget-advanced-count.js" />
/// <reference path="ng/page/adfWidgets/advancedGrid/adf-widget-advanced-grid.js" />
/// <reference path="ng/page/adfWidgets/advancedGrid/advanced.grid.config.service.js" />
/// <reference path="ng/page/adfWidgets/advancedGrid/configFiles/advancedChartConfig.js" />
/// <reference path="ng/page/adfWidgets/analytics/adf-widget-analytics.js" />
/// <reference path="ng/page/adfWidgets/analytics/analytics.config.service.js" />
/// <reference path="ng/page/adfWidgets/analytics/configFiles/analyticsChartConfig.js" />
/// <reference path="ng/page/adfWidgets/analytics/count/adf-widget-analytics-count.js" />
/// <reference path="ng/page/adfWidgets/chart/chart.config.service.js" />
/// <reference path="ng/page/adfWidgets/chart/configFiles/workItemConfig.js" />
/// <reference path="ng/page/adfWidgets/chart/savedSearch/adf-widget-saved-search-combo.js" />
/// <reference path="ng/page/adfWidgets/count/adf-widget-count.js" />
/// <reference path="ng/page/adfWidgets/grid/adf-widget-grid.js" />
/// <reference path="ng/page/adfWidgets/grid/configFiles/advancedChartConfig.js" />
/// <reference path="ng/page/adfWidgets/grid/configFiles/workItemConfig.js" />
/// <reference path="ng/page/adfWidgets/grid/grid.config.service.js" />
/// <reference path="ng/page/adfWidgets/html/adf-widget-html.js" />
/// <reference path="ng/page/adfWidgets/iframe/adf-widget-iframe.js" />
/// <reference path="ng/page/adfWidgets/odataChart/chart/adf-widget-odata-chart.js" />
/// <reference path="ng/page/adfWidgets/odataChart/configFiles/odataChartConfig.js" />
/// <reference path="ng/page/adfWidgets/odataChart/odata.chart.config.service.js" />
/// <reference path="ng/page/adfWidgets/odataCount/adf-widget-odata-count.js" />
/// <reference path="ng/page/adfWidgets/odataGrid/adf-widget-odata-grid.js" />
/// <reference path="ng/page/adfWidgets/odataGrid/configFiles/odataGridConfig.js" />
/// <reference path="ng/page/adfWidgets/odataGrid/odata.grid.config.service.js" />
/// <reference path="ng/page/app.js" />
/// <reference path="ng/page/page.controller.js" />
/// <reference path="ng/page/page.error.controller.js" />
/// <reference path="ng/page/page.service.js" />
/// <reference path="ng/page/pageviewmain.js" />
/// <reference path="ng/ro/app.js" />
/// <reference path="ng/sc/listing/app.js" />
/// <reference path="ng/sc/listing/scListingController.js" />
/// <reference path="ng/sc/listing/scListingMain.js" />
/// <reference path="ng/sc/scfactory.js" />
/// <reference path="ng/shared/directives/abnTreeDirective.js" />
/// <reference path="ng/shared/directives/advancedArticleSearch.js" />
/// <reference path="ng/shared/directives/kbGroup.js" />
/// <reference path="ng/shared/directives/ratingDirective.js" />
/// <reference path="ng/shared/directives/requestSearchResult.js" />
/// <reference path="ng/shared/directives/servicePanel.js" />
/// <reference path="ng/shared/directives/serviceTree.js" />
/// <reference path="ng/shared/directives/tableOfContentsDirective.js" />
/// <reference path="ng/shared/directives/userAvatar.js" />
/// <reference path="ng/shared/filters/caseInsensitiveFilter.js" />
/// <reference path="ng/shared/filters/sortableObjectFilter.js" />
/// <reference path="ng/shared/providers/articleCategoryFactory.js" />
/// <reference path="ng/shared/providers/articleListFactory.js" />
/// <reference path="ng/shared/providers/articleTypeFactory.js" />
/// <reference path="ng/shared/providers/dashboard.query.service.js" />
/// <reference path="ng/shared/providers/localization.service.js" />
/// <reference path="ng/shared/providers/navigation.guard.service.js" />
/// <reference path="ng/shared/providers/navigation.node.service.js" />
/// <reference path="ng/shared/providers/notification.service.js" />
/// <reference path="ng/shared/providers/saved.search.service.js" />
/// <reference path="ng/shared/providers/user.service.js" />
/// <reference path="ng/shared/providers/userAvatarService.js" />
/// <reference path="ng/shared/providers/viewPanel.service.js" />
/// <reference path="ng/slideout-nav/app.js" />
/// <reference path="require.js" />
/// <reference path="require/text.js" />
/// <reference path="structure/column/controller.js" />
/// <reference path="structure/content/controller.js" />
/// <reference path="structure/drawer/gridTask/multiEditController.js" />
/// <reference path="structure/header/controller.js" />
/// <reference path="structure/row/controller.js" />
/// <reference path="structure/tab/tabContent/controller.js" />
/// <reference path="structure/tab/tabData/controller.js" />
/// <reference path="structure/tab/tabNavigation/controller.js" />
/// <reference path="structure/tab/tabPane/controller.js" />
/// <reference path="viewbuilder.js" />
/// <reference path="viewmain.js" />
/// <reference path="viewPanels/affectedUser/app/app.js" />
/// <reference path="viewPanels/affectedUser/app/directives.js" />
/// <reference path="viewPanels/affectedUser/app/ircontroller.js" />
/// <reference path="viewPanels/affectedUser/app/routes.js" />
/// <reference path="viewPanels/affectedUser/app/services.js" />
/// <reference path="viewPanels/affectedUser/app/srcontroller.js" />
/// <reference path="viewPanels/affectedUser/scripts/init.js" />
/// <reference path="viewpanels/alternatesc/controller.js" />
/// <reference path="viewpanels/articlelist/controller.js" />
/// <reference path="viewpanels/calendar/controller.js" />
/// <reference path="viewpanels/chart/controller.js" />
/// <reference path="viewpanels/facetedsearch/controller.js" />
/// <reference path="viewpanels/html/controller.js" />
/// <reference path="viewpanels/querybuilder/controller.js" />
/// <reference path="viewpanels/radialgauge/controller.js" />
/// <reference path="viewpanels/servicecatalog/controller.js" />
/// <reference path="viewpanels/trendcontainer/controller.js" />
/// <reference path="viewpanels/viewpanelbuilder.js" />
/// <reference path="views/affectedUser.js" />
/// <reference path="views/localizationadmin.js" />
/// <reference path="views/navigationadmin.js" />
/// <reference path="views/viewpanels/kbhomesearch.js" />
/// <reference path="views/viewpanels/localizationgrid.js" />
/// <reference path="widgets/custom-bindings.js" />
