﻿var app = (!app) ? {} : app;

//simple event bus
//http://stackoverflow.com/questions/2967332/jquery-plugin-for-event-driven-architecture
app.events = {
    subscribe: function (event, fn) {
        $(this).bind(event, fn);
    },
    unsubscribe: function (event, fn) {
        $(this).unbind(event, fn);
    },
    publish: function (event, eventData) {
        $(this).trigger(event, eventData);
    }
};


app.lib = function () {
    var that = this;
    var logs = [];
    var onPageLoadInit = function () {
        $(function () {
            $(document.body).on("keyup", ":input", function (e) {
                if (e.which == 13)
                    $(this).trigger("enter");
            });
        });
    }
    onPageLoadInit();
    this.stopEnterKeySubmitting = function (e) {
        if (e.keyCode == 13) {
            var src = e.srcElement || e.target;
            if (src.tagName.toLowerCase() != "textarea") {
                if (e.preventDefault) {
                    e.preventDefault();
                } else {
                    e.returnValue = false;
                }
            }
        }
    }

    this.exception = function (message) {
        throw message;
    }
    this.log = function (message) {
        logs.push(message);
    }
    this.getLogs = function () {
        return logs;
    }
    this.forceKendoProp = function (boundObj, propName, type) {
        if (!boundObj[propName]) {
            if ($.type(type) == "object") {
                boundObj.set(propName, new kendo.data.ObservableObject(type)); //need to use set functions on kendo observables to trigger change correctly
            } else if ($.type(type) == "array") {
                boundObj.set(propName, new kendo.data.ObservableArray(type)); //need to use set functions on kendo observables to trigger change correctly
            }
            app.lib.log(propName + " was added to viewModel dynamically from controls");
            boundObj[propName].bind("change", function (e) {
                if (typeof onVmChange != "undefined") {
                    onVmChange(e);
                }
            });
        }
    }
    this.addUrlParam = function (url, key, value) {
        key = encodeURI(key);
        value = encodeURI(value);
        var urlSplit = url.split('?');
        var cleanUrl = urlSplit[0];
        var newProp = key + "=" + value;
        if (urlSplit.length > 1) {
            return cleanUrl + "?" + newProp + "&" + urlSplit[1];
        } else {
            return cleanUrl + "?" + newProp;
        }
    }
    //TODO: cant we do this with underscore
    this.getArrayItemById = function (array, id) {
        var itm = false;
        $.each(array, function (i, item) {
            if (item.Id == id) {
                itm = item;
            }
        });
        return itm;
    }
    this.newGUID = function () {
        var s4 = function () {
            return Math.floor((1 + Math.random()) * 0x10000)
                        .toString(16)
                        .substring(1);
        };
        var guid = function () {
            return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
                    s4() + '-' + s4() + s4() + s4();
        }
        return guid();
    }
    this.runOnPageLoad = {
        // func: string to be evaled.
        add: function (func) {
            document.cookie = "cireson_app_lib_runOnPageLoad=" + encodeURIComponent(func) + "; path=/";
        },
        run: function () {
            var func = (document.cookie.match('(^|; )cireson_app_lib_runOnPageLoad=([^;]*)') || 0)[2];
            if (func) {
                func = decodeURIComponent(func);
                setTimeout(function () {
                    eval(func);
                }, 300);
                document.cookie = "cireson_app_lib_runOnPageLoad=; path=/";
            }
        }
    }

    this.message = {
        add: function (text, type) {
            // type: warning, success, info, danger, null, undefined
            //document.cookie = "cireson_app_lib_message=" + JSON.stringify({ text: encodeURIComponent(text), type: encodeURIComponent(type) }) + "; path=/; HttpOnly";

            //lets use local storage in a smart way
            try {
                //localStorage.setItem("cireson_app_lib_message", JSON.stringify({ text: encodeURIComponent(text), type: encodeURIComponent(type) }));
                store.session.set("cireson_app_lib_message", JSON.stringify({ text: encodeURIComponent(text), type: encodeURIComponent(type) }));
                return;
            } catch (e) {
                return;
            }
        },
        show: function () {

            //var message = (document.cookie.match('(^|; )cireson_app_lib_message=([^;]*)') || 0)[2];

            try {
                //var message = localStorage.getItem("cireson_app_lib_message");
                var message = store.session.get("cireson_app_lib_message");

            } catch (e) {

            }

            if (message && message != "") {
                message = JSON.parse(message);
                message.text = decodeURIComponent(message.text);
                message.type = decodeURIComponent(message.type);
                // show message
                var container = $('#alertMessagesContainer');
                if (!container) {
                    kendo.ui.ExtAlertDialog.show({
                        title: localization.Warning,
                        message: message.text + "\n\n\n" + "message container is missing, #alertMessagesContainer"
                    });
                } else {
                    //remove any old ones
                    container.children('.alert').remove();

                    var box = $('<div>', { 'class': 'alert', html: message.text });
                    if (message.type) {
                        box.addClass("alert-" + message.type);
                    }
                    if (app.isMobile()) {
                        box.addClass("alert-mobile");
                    }
                    container.append(box);

                    //hide after some time
                    setTimeout(function () {
                        container.children('.alert').slideUp();
                    }, 20000);
                }
                //document.cookie = "cireson_app_lib_message=; path=/";

                try {
                    //var message = localStorage.removeItem("cireson_app_lib_message");
                    var message = store.session.remove("cireson_app_lib_message");

                } catch (e) {

                }

            }
        },
        hide: function () {
            var container = $('#alertMessagesContainer');

            if (!container) {
                kendo.ui.ExtAlertDialog.show({
                    title: localization.Warning,
                    message: message.text + "\n\n\n" + "message container is missing, #alertMessagesContainer"
                });
            } else {
                container.children('.alert').remove();
            }
        }
    }
    this.mask = { //an odject to handle custom assigned from tasks
        apply: function (label) {
            var div = $('<div>', { "class": "k-overlay form-overlay" });
            //add the html need for the laoding animation
            div.html('<div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>');
            div.append(label);

            div.appendTo('body');
        },
        whiteOut: function (label) {
            var div = $('<div>', { "class": "k-overlay form-overlay white-out" });
            //add the html need for the laoding animation
            div.html('<div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>');
            div.append(label);

            div.appendTo('body');
        },
        remove: function () {
            $('div.k-overlay.form-overlay').remove();
        }
    }
    this.extTemplate = {
        load: function (path) {
            var tmplLoader = $.get(path)
				.success(function (result) {
				    //Add templates to DOM
				    $("body").append(result);

				})
				.error(function (result) {
				    console.log("Error Loading Template: " + path);
				})

            tmplLoader.complete(function () {
                $(document).trigger("TEMPLATE_LOADED", [path]);
            });
        }
    }
    // returns cloned dom fragment with matching data-template
    this.getTemplate = function (name) {
        return $('[data-template="' + name + '"]').clone(true).removeAttr('data-template').show();
    }
    this.objectDiff = function (obj1, obj2) {
        return _.isEqual(obj1, obj2);
    }

    this.handleMessages = function () {
        app.lib.message.show();
    }

    // used for pulling functions out of definition files. (http://stackoverflow.com/a/12380392)
    // since valid json cannot store a function, we store
    // them by name as a string.
    // returns the function or undefined.
    this.getFunctionFromString = function (string) {
        if (_.isUndefined(string)) {
            return null;
        }
        var scope = window;
        //remove () if it is there.
        if (string.indexOf('(') !== -1) {
            string = string.split('(')[0];
        }
        var scopeSplit = string.split('.');
        var i;
        for (i = 0; i < scopeSplit.length - 1; i++) {
            scope = scope[scopeSplit[i]];
            if (scope == undefined) {
                return null;
            }
        }
        return scope[scopeSplit[scopeSplit.length - 1]];
    }


    //used for page/form definition
    this.setColumnSizes = function (colList) {

        var numCols = 0;

        _.each(colList, function (col) {
            numCols += (col.ColSpan) ? col.ColSpan : 1;
        });

        _.each(colList, function (col) {
            //calcualte the bootstrap grid width
            //(12/(totalCols [3])) * colspan [1] = 4
            var colspan = (col.ColSpan) ? col.ColSpan : 1;
            col.ColSpan = colspan;
            col.ColSize = (12 / numCols) * colspan;
        });
    }
    //used for wrapping raw html strings in a jquery object
    this.getContainer = function (tplReturn) {
        return (typeof (tplReturn) === "string") ? $(tplReturn) : tplReturn;
    }

    this.showErrorMessage = function (message) {
        kendo.ui.ExtAlertDialog.show({
            title: localization.Warning,
            message: message
        });
    }

    this.getViewPanelDefinition = function (panelId, callback) {
        var node = _.findWhere(app.storage.viewPanels.session.get('all'), { Id: panelId });
        if (_.isUndefined(node)) {
            var name = panelId;
            if (panelId.indexOf(".js") == -1) {
                name = panelId + '.js';
            }
            //check for matching definition file in customspace
            $.ajax({
                type: 'GET',
                dataType: 'text',
                url: '/customspace/views/viewPanels/' + name,
                async: false,
                success: function(template) {
                    var templateObj = $.parseJSON(template);
                    callback(templateObj);
                },
                error: function() {
                    //final check here, for internal/old definition support
                    $.ajax({
                        type: 'GET',
                        dataType: 'text',
                        url: '/scripts/views/viewPanels/' + name,
                        async: false
                    }).done(function(template) {
                        var templateObj = $.parseJSON(template);
                        callback(templateObj);
                    });
                }
            });
        } else {
            callback(node);
        }
    };

    this.getNavNode = function (callback) {
        var nodeId = app.getNavNodeIdFromUrl();
        var nodes = app.storage.nodes.session.get('all');
        var matchedNode;

        //todo: abstract this..
        function findNode(node) {
            if (node.Id == nodeId) {
                matchedNode = node;
            }
            _.each(node.Children, function (child) {
                findNode(child);
            });
        };
        _.each(nodes, function (node) {
            findNode(node);
        });

        if (_.isUndefined(matchedNode)) {
            callback(null);
        } else {
            callback(matchedNode);
        }
    };

    this.getNavNodeDefinition = function (callback) {

        this.getNavNode(function (matchedNode) {

            if (_.isNull(matchedNode)) {
                var name = app.getNavNodeIdFromUrl();
                if (name.indexOf(".js") == -1) {
                    name = name + '.js';
                };

                //check if name matches file in customspace, load that
                $.ajax({
                    type: 'GET',
                    dataType: 'text',
                    url: '/customspace/views/' + name,
                    async: false,
                    success: function (template) {
                        var templateObj = $.parseJSON(template);
                            callback(templateObj);
                    },
                    error: function() {
                        //final check here, for internal/old definition support
                        $.ajax({
                            type: 'GET',
                            dataType: 'text',
                            url: '/scripts/views/' + name,
                            async: false,
                            success: function(template) {
                                var templateObj = $.parseJSON(template);
                                callback(templateObj);
                            }
                        });
                    }
                });

            } else {
                callback(matchedNode.Definition);
            }
        });
    };

    //returns object only if it is valid json
    this.tryParseJSON = function (jsonString) {
        if (_.isObject(jsonString)) {
            return jsonString;
        }

        try {
            var jsonObject = $.parseJSON(jsonString);

            //note: $.parseJSON(null) and $.parseJSON(1234) will not throw errors AND null is an object
            //      make sure we filter those out
            if (_.isObject(jsonObject) && !_.isNull(jsonObject)) {
                return jsonObject;
            }
        }
        catch (e) { }

        return false;
    };



    this.isDateValue = function (value) {
        var val = value;
        if (val) {
            val = val.toString().replace(/\s+/, "");
            if (Date.parse(val) && /^\d+$/.test(val) === false && parseFloat(val))
                return true;
        }
        return false;
    }

    ///From: https://gist.github.com/ryoppy/5780748
    /**
     * Parse query string.
     * ?a=b&c=d to {a: b, c: d}
     * @param {String} (option) queryString
     * @return {Object} query params
     */
    this.getQueryParams = function (queryString) {
        var query = (queryString || window.location.search || window.location.hash.replace("#/", '')).substring(1); // delete ?
        if (!query) {
            return false;
        }
        return _
        .chain(query.split('&'))
        .map(function (params) {
            var p = params.split('=');
            return [p[0].toLowerCase(), decodeURIComponent(p[1])];
        })
        .object()
        .value();
    }

    this.recurse = function (items, field, depthFirst, callback, parent, depth) {
        if (!items) return;
        if (depth === undefined) depth = 0;

        for (var i = 0; i < items.length; i++) {
            if (!depthFirst) callback(items[i], i, depth, parent);
            recurse(items[i][field], field, depthFirst, callback, items[i], depth + 1);
            if (depthFirst) callback(items[i], i, depth, parent);
        }
    }

    this.CheckedStartAndEndDate = function (startDateName, endDateName, errorMessage) {
        var startDateInput = $("input[name='" + startDateName + "']");
        var endDateInput = $("input[name='" + endDateName + "']");

        //var startDatePickerType = startDateInput.attr("data-control");
        //var endDatePickerType = endDateInput.attr("data-control");

        //var StartDate = (startDatePickerType == "dateTimePicker") ? startDateInput.data("kendoDateTimePicker") : startDateInput.data("kendoDatePicker");
        //var EndDate = (endDatePickerType == "dateTimePicker") ? endDateInput.data("kendoDateTimePicker") : endDateInput.data("kendoDatePicker");

        //var StartDateVal = kendo.parseDate(StartDate.value());
        //var EndDateVal = kendo.parseDate(EndDate.value());
        var StartDateVal = kendo.parseDate(startDateInput.val());
        var EndDateVal = kendo.parseDate(endDateInput.val());
        if (EndDateVal > StartDateVal) {
            return true;
        }

        kendo.ui.ExtOkCancelDialog.show({
            title: localization.Warning,
            message: errorMessage,
            icon: "fa fa-exclamation"
        });
        return false;
    }
    this.CheckedManualActivityStartAndEndDate = function (startDateName, endDateName, errorMessage) {

        var StartDateVal = kendo.parseDate(startDateName);
        var EndDateVal = kendo.parseDate(endDateName);
        //only check if end date is later when both values are set
        if (!_.isNull(startDateName) && !_.isNull(endDateName)) {
            if (EndDateVal < StartDateVal) {

                kendo.ui.ExtOkCancelDialog.show({
                    title: localization.Warning,
                    message: errorMessage,
                    icon: "fa fa-exclamation"
                });
                return false;
            }
        }

        return true;


    }

    this.SetDaysLeft = function (startDate, endDate, dataVM, modelKey) {
        if (startDate != "" && endDate != "") {
            var start = kendo.parseDate(startDate);
            var end = kendo.parseDate(endDate);
            if (start >= end) {
                dataVM.set(modelKey, 0);
            } else {
                var result = app.lib.GetDaysBetween(new Date(), end);
                dataVM.set(modelKey, result < 0 ? 0 : result);
            }
        }
    }

    this.GetDaysLeft = function (startDate, endDate) {
        var daysLeft = 0;
        if (startDate != "" && endDate != "") {
            var start = kendo.parseDate(startDate);
            var end = kendo.parseDate(endDate);
            if (start >= end) {
                daysLeft = 0;
            } else {
                daysLeft = app.lib.GetDaysBetween(new Date(), end);
            }
        }

        return daysLeft < 0 ? 0 : daysLeft;
    }

    this.GetDaysBetween = function (first, second) {
        var diff = new Date(second).setHours(12) - new Date(first).setHours(12);
        return Math.round(diff / 8.64e7);
    }

    this.logout = function (formId) {
        app.clearNodeAndViewPanelStorage();
        $('#' + formId).submit();
    }

    //lets store form return urls in session so it easier to send user back where they belong
    this.getFormReturnUrl = function () {
        return store.session.get("formReturnUrl:" + window.location.pathname);
    }

    //set the form return URL with the option to force over writing exisitng url
    this.setFormReturnUrl = function (url, force) {
        force = _.isUndefined(force) ? false : true;

        if (force && url.length > 0) {
            store.session.set("formReturnUrl:" + window.location.pathname, url);
        } else if (_.isNull(this.getFormReturnUrl()) && url.length > 0) {
            store.session.set("formReturnUrl:" + window.location.pathname, url);
        }

        return this.getFormReturnUrl();
    }

    this.removeFormReturnUrl = function () {
        return store.session.remove("formReturnUrl:" + window.location.pathname);
    }

    this.gotoFormReturnUrl = function () {

        var windowOpener;
        var homeURL = "/";

        try {
            //when IR opened from a diff domain it will fail on window.opener.location
            if (window.opener && window.opener.location.host) {
                windowOpener = window.opener;
            }
        } catch (e) {
            windowOpener = false;
        }


        if (windowOpener) {
            if ((window.opener.location.host === window.location.host) &&
            history.length < 2 //if they browse away don't close the form, reloads don't add to history count
            ) {
                //we have a window that was opened from another portal window
                //let's first clear out the return URL in the session

                this.removeFormReturnUrl();

                //now lets just close ourself
                window.close();
            } else {
                //does new tab will cross this line.
                location.href = homeURL;
            }
        } else {
            //when return url was empty then redirect to alternate homepage.
            if (history.length > 2) {
                //do the normal thing
                if (_.isNull(this.getFormReturnUrl())) {
                    //when previous page is not the login page, go back to document referrer if it isnt empty else to fallback url
                    if (document.referrer.indexOf("/Login") == -1 && document.referrer != "")
                        location.href = document.referrer;
                    else
                        location.href = homeURL;
                } else {
                    //there were instances were domain/host name was omitted, so send down the absolute path instead
                    var origin = location.protocol + '//' + location.hostname + (location.port ? (':' + location.port) : '');
                    var absolutePath = origin + this.getFormReturnUrl();
                    location.href = absolutePath;
                }
            } else {
                //alternate homepage redirect.
                location.href = homeURL;
            }
            return;
        }

    }

    // used to make sure we have an actually dom element when using selector.
    //$('#' + gridId + ' td').exists()
    $.fn.exists = function () {
        return this.length > 0 ? this : false;
    }

    //used for removing unsafe tags on input forms
    this.escapeHTML = function (unsafe_str) { // this was done for crossbrowser issue
        return unsafe_str
          //.replace(/&/g, '&emp;')
          .replace(/</g, '')
          .replace(/>/g, '')
          .replace(/\"/g, '');
    },

    //encode html special chars
    this.htmlEntities = function (str) {
        return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
    }

    this.recheckGridState = function (state, grid) {
        if (_.isUndefined(state.page)) {
            state.page = grid.dataSource.options.page;
        }
        if (_.isUndefined(state.pageSize)) {
            state.page = grid.dataSource.options.pageSize;
        }
    }

    this.getPriorityByMatrix = function (priorityJson, urgencyId, impactId) {
        if (!priorityJson) {
            return null;
        }

        var priority = 0;
        var priorityJsonU = priorityJson.Matrix.U;
        for (var i in priorityJsonU) {
            var obj = priorityJsonU[i];
            if (obj.Id == urgencyId) {
                for (var x in obj.I) {
                    var obj2 = obj.I[x];
                    if (obj2.Id == impactId) {
                        priority = obj2.P;
                        break;
                    } else {
                        priority = 0;
                    }
                }
            }
        }

        return priority;
    }

    this.getLocalDateFromUTCDate = function (date) {
        return new Date(Date.UTC(
            date.getFullYear(),
            date.getMonth(),
            date.getDate(),
            date.getHours(),
            date.getMinutes(),
            date.getSeconds()));
    }

    //takes date param as string or js Date object, returns local datetime with locale formatting as string
    this.getFormattedLocalDateTime = function (date) {
        if (!_.isDate(date) && !_.isString(date)) {
            //if it is not a date or string, just return what was sent to us
            return date;
        }
        var localDate = null;
        var formattedDateString = '';

        switch (true) {
            case _.isDate(date):
                //this will be a date object from the server that is in UTC time
                localDate = app.lib.getLocalDateFromUTCDate(date);
                break;
            case _.isString(date) && date.length > 0:
                //check if we have UTC on the string, if so parse it first (User Inputs bug fix)
                if (date.indexOf('UTC') > 0) {
                    // user inputs on form are in a different string format, so we kendo parse first, then use the helper
                    localDate = kendo.parseDate(date);
                    localDate = app.lib.getLocalDateFromUTCDate(localDate);
                } else {
                    localDate = app.lib.getLocalDateFromUTCDate(new Date(date));
                }
                break;
            default:
                localDate = null;
        }


        if (_.isNull(localDate)) {
            formattedDateString = '';
        } else {
            formattedDateString = kendo.toString(localDate, 'g');
        }
        return formattedDateString;
    }

    this.ToggleTextboxRequired = function (element, isRequired) {
        var formGroup = element.parents(".form-group");
        if (isRequired) {
            element.attr("required", "");
            formGroup.find("span:last").show(); //this will show required text
        }
        else {
            element.removeAttr("required");
            formGroup.removeClass("has-error").find("span:last").hide(); //this will hide required text
        }
    }

    this.isDefined = function (object) {
        var isNotNull = object != null;
        var isNotUndefined = !_.isUndefined(object);
        return isNotNull && isNotUndefined;
    };

    this.knowledgeManagerDeleteArticle = function (articleId, controlId) {
        var control;
        if (_.isString(controlId)) {
            control = $('#' + controlId).data('kendoGrid');
        }
        if (app.isMobile()) {
            control = $(controlId).closest("[data-control-id]").data('kendoListView');
            //control = $("[data-control-id='" + controlId + "']").data('kendoListView');
        }

        //confirm before archiving.
        $.when(kendo.ui.ExtOkCancelDialog.show({
            title: localization.Warning,
            message: localization.ConfirmArchiveArticle,
            icon: "fa fa-exclamation"
        })).done(function (response) {
            if (response.button === "ok") {
                $.ajax({
                    type: "PATCH",
                    url: '/api/V3/Article/Patch/?articleId=' + articleId,
                    success: function () {
                        //sync data to update UI
                        if (app.isMobile()) {
                            control.dataSource.query();
                        } else {
                            control.dataSource.read();
                        }
                    }
                });
            }
        });
    }

    this.vmParseFloat = function (vm, propertyName) { //This will going to set vm to 0 if float is NaN.
        if (_.isNaN(parseFloat(vm.get(propertyName)))) {
            vm.set(propertyName, 0);
        };

        return parseFloat(vm.get(propertyName));
    }

    this.makeDrawer = function (direction, drawerContainer, elementBtnObj, closeOnContainerClick) {
        // class to use for transition
        var transitionClass = 'header_slide_transition';
        // parent of drawer container use for removing its children transitionClass if present.
        var containerParent = drawerContainer.parent();
        // This where hide the drawer elements.
        function hideContainer() {
            containerParent.children().each(function () {
                $(this).removeClass(transitionClass);
            });
        }
        // Click an element to on and off the drawer container.
        elementBtnObj.on('click', function () {
            // for task panel button
            if (elementBtnObj.hasClass('btn-link')) {
                transitionClass = 'task_slide_transition';
               
                if (drawerContainer.hasClass(transitionClass)) {
                    drawerContainer.removeClass(transitionClass);
                    $('body').removeClass('noscroll');
                } else {
                    //Bug 11429: this implemenation to prevent overall changes for the less files affected in this issue.
                    var netHeight = ($(window).height() - 40);//less the header height which is 40px.
                    if (drawerContainer.height() > netHeight) {
                        var height = netHeight - 30;
                        var styles = { height: height + 'px', overflow: 'scroll' };

                        $('body').addClass('noscroll');
                        //drawerContainer.css(styles);
                    }
                    drawerContainer.addClass(transitionClass);
                }
                return;
            }
            // for drawer buttons
            if (drawerContainer.hasClass(transitionClass)) {
                drawerContainer.removeClass(transitionClass);
            } else {
                hideContainer();
                drawerContainer.addClass(transitionClass);
            }
        });
        //This will going to close the drawer if you click it outside
        $(document).click(function (e) {
            if (!elementBtnObj.children('span').is(e.target)
             && elementBtnObj.children('span').has(e.target).length === 0
             && !drawerContainer.is(e.target)
             && drawerContainer.has(e.target).length === 0) {
                //remove the class when clicking any element outside the drawer.
                drawerContainer.removeClass(transitionClass);
            }
        });
    }

    this.filterMobileWiGrid = function (controlId) {
        var listControl = $("[data-control-id='" + controlId + "']").data('kendoListView');
        var dataSource = listControl.dataSource;
        var searchValue = $("input[name=mobileWiGridSearchText]").val();

        $(".mobilegrid__search--help-block").addClass('visible');

        //apply search to title field
        dataSource.query({
            filter: { field: "Title", operator: "contains", value: searchValue },
            page: 1,
            pageSize: 10
        });
    };

    this.adminSettingsTaskPanel = function (settings) {
        var self = $(settings.id);
        var html = "";

        if (app.isMobile()) {
            html = '<div class="nav-dropdown">' +
                   '<span class="nav-dropdown-default">' +
                   settings.active + '</span>' +
                   '<div class="nav-dropdown-trigger">' +
                   '<i class="fa fa-sort-desc"></i></div>' +
                   '<div class="nav-dropdown-content">' +
                   '<ul>' + generateListElement() + '</ul></div></div>';

            
        } else {
            html = '<div class="admin-sidenav col-sm-3 sidebar-right pad-top-1-5">' +
                   '<nav class="tree-dir sidebar-nav">' +
                   '<ul class="nav sidenav abn-tree">' +
                   generateListElement() + '</ul></nav></div>';
        }

        function generateListElement() {
            var listItem = validateListItem(0,"/Settings/Admin/General", localizationHelper.localize("GeneralSettings", "General Settings"), true) +
                           validateListItem(0,"/Settings/Admin/LicenseSettings", localizationHelper.localize("LicenseSettings", "License Settings"), true) +
                           validateListItem(3, "", localizationHelper.localize("EmailSettings", "Email Settings"), true) +
                           validateListItem(-1, "/Settings/Admin/SMTPDetailsSettings", localizationHelper.localize("SMTPDetails", "SMTP Details"), true) +
                           validateListItem(-1, "/Settings/Admin/SendEmailTaskSettings", localizationHelper.localize("SendEmailTask", "Send Email Task"), true) +
                           validateListItem(-1, "/Settings/Admin/MentionsNotificationSettings", localizationHelper.localize("ActionLogMentionsNotification", "Action Log Mentions Notification"), true) +
                           validateListItem(0, "/Settings/Admin/WorkItemsSettings", localizationHelper.localize("WorkItemSettings", "WorkItem Settings"), true) +
                           validateListItem(0,"/Settings/Admin/ActivitySettings", localizationHelper.localize("ActivitySettings", "Activity Settings"), true) +
                           validateListItem(0,"/Settings/Admin/GroupSettings", localizationHelper.localize("GroupSettings", "Group Settings"), true) +
                           validateListItem(0,"/Settings/Admin/DataRetentionSettings", localizationHelper.localize("DataRetentionSettings", "Data Retention Settings"), undefinedChecking(settings.isValidDashboardsLicense)) +
                           validateListItem(0,"/Settings/Admin/DataSourceSettings", localizationHelper.localize("DataSourceSettings", "Data Source Settings"), undefinedChecking(settings.isValidDashboardsLicense)) +
                           validateListItem(0,"/Settings/Admin/DashboardQuerySettings", localizationHelper.localize("DashboardQuerySettings", "Dashboard Query Settings"), undefinedChecking(settings.isValidDashboardsLicense)) +
                           validateListItem(0,"/Settings/Admin/HeaderFooterScriptSettings", localizationHelper.localize("HeaderFooterScriptSettings", "Header & Footer Script Settings"), true) +
                           validateListItem(0,"/Settings/Admin/IntegrationSettings", localizationHelper.localize("IntegrationSettings", "Integration Settings"), true) +
                           validateListItem(0,"/Settings/Admin/SettingItems", localizationHelper.localize("SettingItems", "Setting Items"), true);
            return listItem;
        }

        function undefinedChecking(obj) {
            return (obj === undefined) ? true : obj;
        }

        function validateListItem(children, href, localize, isValid) {
            if (isValid) {
                if (children < 0) {
                    return (settings.active === localize)
                        ? (app.isMobile())
                        ? '<li  class="level-2 active margin-l20 text-muted">' +
                        localize +
                        '</li>'
                        : '<li  class="level-2 active margin-l20">' +
                        localize +
                        '</li>'
                        : '<li class="level-2 margin-l20 hide"><a href="' + href + '">' + localize + '</a></li>' ;
                }else if (children > 0) {
                    var childText = '<small>(' + children + ')</small>';
                    return '<li class="level-1" onclick="app.lib.toggleSubList(this, ' + children + ')"><a href="#">' + localize + ' ' + childText + '<i ng-class="row.icon" class="tree-icon pull-right fa fa-chevron-left"></i></a></li>';
                } else {
                    return (settings.active === localize)
                        ? (app.isMobile())
                        ? '<li class="hide"></li>'
                        : '<li>' +
                        localize +
                        '</li>'
                        : '<li><a href="' + href + '">' + localize + '</a></li>';
                }
            }
            return '<li class="hide"></li>'; //prevent showing undefiend when isValid false.
        }

        

        self.append(html);

        var childElement = self.find('li.level-2.active')[0];
        if (childElement) {
            var parentELement = $(childElement).siblings('li.level-1')[0];
            if (parentELement) $(parentELement).click();
        }

        if (app.isMobile()) {
            self.find('.nav-dropdown-trigger').on('click', function () {
                self.toggleClass('show-nav-content');
            });
        }
    };

    this.toggleSubList = function(el, children) {
        var collapsed = $(el).find('i').hasClass('fa-chevron-left');
        var expanded = $(el).find('i').hasClass('fa-chevron-down');
        var iElement = $(el).find('i')[0];

        if (collapsed) {
            $(iElement).removeClass('fa-chevron-left');
            $(iElement).addClass('fa-chevron-down');
        }

        if (expanded) {
            $(iElement).removeClass('fa-chevron-down');
            $(iElement).addClass('fa-chevron-left');
        }

        var sub = $(el).next('.level-2');
        for (var i = 0; i < children; i++) {
            if (collapsed) $(sub).removeClass('hide');
            if (expanded) $(sub).addClass('hide');
            sub = $(sub).next('.level-2');
        }
    }

    this.optimizeFormMultiObject = { //This will be used to optimized multi object picker to only pass data that will be remove or/and add when saving the form.
        newItem: [],
        deletedItem: [],
        ExcludedProperty: ["NameRelationship", "Activity", "FileAttachment", "AppliesToWorkItem", "AppliesToTroubleTicket", "RelatedHTMLKB", "RemoveRelatedHTMLKB",
                            "Target_LeaseSupersedesLease", "Source_LeaseSupersedesLease", "Target_WarrantySupersedesWarranty", "Source_WarrantySupersedesWarranty",
                            "Target_SupportContractSupersedesSupportContract", "Source_SupportContractSupersedesSupportContract", "WatchList", "ChildWorkItem"],
        OnVmChange: function (e) {
            //This will going to add or remove the items to a temporary array to be used on removing and adding items that will be only be needed for saving.
            //This will be triggerd when you add or remove a items from mulitple object picker.
            if (e.action != null) {
                var field = e.field;
                var item = e.items[0];
                if (app.lib.optimizeFormMultiObject.newItem[field] == null) {
                    app.lib.optimizeFormMultiObject.newItem[field] = [];
                    app.lib.optimizeFormMultiObject.deletedItem[field] = [];
                }
                if (e.action == "add") { //when you add the items on the grid
                    app.lib.optimizeFormMultiObject.newItem[field].push({
                        BaseId: item.BaseId
                    });

                    var temp = app.lib.optimizeFormMultiObject.deletedItem[field];
                    for (var i in temp) {
                        if (item.BaseId == temp[i].BaseId) {
                            app.lib.optimizeFormMultiObject.deletedItem[field].splice(i, 1);
                        }
                    }
                }
                else if (e.action == "remove") { //When you remove the items from the grid
                    app.lib.optimizeFormMultiObject.deletedItem[field].push({
                        BaseId: item.BaseId
                    });

                    var temp = app.lib.optimizeFormMultiObject.newItem[field];
                    for (var i in temp) {
                        if (item.BaseId == temp[i].BaseId) {
                            app.lib.optimizeFormMultiObject.newItem[field].splice(i, 1);
                        }
                    }
                }
            }
        },

        BeforeSave: function (currentVM, originalVM) {
            //This will be triggered before the data is created to be passed to the server.
            //This will going to empty all property that is array except for "NameRelationship" and will add the items to be added or/and removed to the relationship.
            //This will rely on the optimizeFormMultiObject.OnVmChange method.
            //NOTE: all new added items will be stored in currentVM and all items that will be deleted will be stored in originalVM.

            var tempDeleted = [];
            var newItem = app.lib.optimizeFormMultiObject.newItem;
            var deletedItem = app.lib.optimizeFormMultiObject.deletedItem;

            for (var i in originalVM) {
                if (app.lib.optimizeFormMultiObject.IsPropertyExcluded(i) && Object.prototype.toString.call(originalVM[i]) === '[object Array]') { }
                else if (Object.prototype.toString.call(originalVM[i]) === '[object Array]')
                {
                    var tempAdded = [];
                    //This will going to check add the needed items to be remove when saving.
                    for (var iAdded in originalVM[i]) {
                        for (var iNew in deletedItem[i]) {
                            if (originalVM[i][iAdded].BaseId == deletedItem[i][iNew].BaseId) {
                                tempAdded.push(originalVM[i][iAdded]);
                            }
                        }
                    }

                    originalVM[i] = []; //This will clear out the relationship array.
                    for (var newI in tempAdded) { //this will add the the items the will be removed to the current relationship.
                        originalVM[i].push(tempAdded[newI]);
                    }
                }
            }

            //Thiw will going to clear out the relationship array.
            for (var i in currentVM) {
                if (app.lib.optimizeFormMultiObject.IsPropertyExcluded(i) && Object.prototype.toString.call(currentVM[i]) === '[object Array]') { }
                else if (Object.prototype.toString.call(currentVM[i]) === '[object Array]')
                {
                    delete currentVM[i];
                }
            }
             
            //This will add the new items selected to be save.
            for (var iAdded in newItem) {
                if (app.lib.optimizeFormMultiObject.IsPropertyExcluded(iAdded)) continue;
                currentVM[iAdded] = newItem[iAdded];
            }
        },

        IsPropertyExcluded: function (propertyName) {
            for (var i in app.lib.optimizeFormMultiObject.ExcludedProperty)
            {
                if (propertyName == app.lib.optimizeFormMultiObject.ExcludedProperty[i])
                {
                    return true;
                }
            }
            return false;
        }

        
    }
    this.getLinkUrl = function (type, id) {
        var link = "";
        switch (type) {
            case "ChangeRequest":
                link = "/ChangeRequest/Edit/" + id + "/";
                break;
            case "ServiceRequest":
                link = "/ServiceRequest/Edit/" + id + "/";
                break;
            case "Problem":
                link = "/Problem/Edit/" + id + "/";
                break;
            case "ReleaseRecord":
                link = "/ReleaseRecord/Edit/" + id + "/";
                break;
            case "ManualActivity":
            case "ReviewActivity":
                link = "/Activity/Edit/" + id + "/";
                break;
            default:
            case "Incident":
                link = "/Incident/Edit/" + id + "/";
                break;

        }
        return link;
    }
 
    this.getQueryResultDisplayText = function (userInput) {
        //if the user input has a tag in it it will break this
        //so lets make sure we have the value
        if (!_.isUndefined(userInput.Answer.Values) && !_.isUndefined(userInput.Answer.Values.Value)) {
            var values = userInput.Answer.Values.Value;
            var displayVals = new Array();
            if (values.length > 1) {
                for (var j in values) {
                    displayVals.push(values[j]['DisplayName']);
                }
            } else {
                displayVals.push(values['DisplayName']);
            }

            //manipulate array
            displayVals = displayVals.filter(function (e) { return e });
            displayVals.sort();
            
            return displayVals.join('<br/>');;
        } else {
            console.warn("Error Parsing User Input for: " + userInput.Question);
        }
        return "";
    }

    this.getEnumDisplayName = function (enumId, callback) {
        return $.ajax({
            type: 'GET',
            async: false,
            timeout: 5000,
            url: '/api/V3/Enum/GetEnumDisplayName',
            data: { Id: enumId },
            success: function(data) {
                callback(data);
            }
        }); 
    }

    this.sanitizeURL = function (url) {
        return decodeURIComponent(url).replace(/(\/#|\/|#)$/, '');
    }

    this.getSetting = function (key, callback) {
        return $.ajax({
            type: 'GET',
            async: false,
            timeout: 5000,
            url: '/api/V3/Settings/GetSetting',
            data: { settingKey: key },
            success: function (data) {
                callback(data);
            }
        });
    }

    this.getChangeStatusRules = function () {
        var workItemStatuses = app.constants.workItemStatuses;
        var incidentResolved = workItemStatuses.Incident.Resolved;
        var incidentActive = workItemStatuses.Incident.Active;
        var incidentClosed = workItemStatuses.Incident.Closed;
        var incidentActivePending = workItemStatuses.Incident.Pending;
        var serviceRequestCancelled = workItemStatuses.ServiceRequest.Cancelled;
        var serviceRequestCompleted = workItemStatuses.ServiceRequest.Completed;
        var serviceRequestSubmitted = workItemStatuses.ServiceRequest.Submitted;
        var serviceRequestInProgress = workItemStatuses.ServiceRequest.InProgress;
        var serviceRequestOnHold = workItemStatuses.ServiceRequest.OnHold;
        var serviceRequestFailed = workItemStatuses.ServiceRequest.Failed;
        var serviceRequestClosed = workItemStatuses.ServiceRequest.Closed;
        var changeRequestFailed = workItemStatuses.ChangeRequest.Failed;
        var changeRequestClosed = workItemStatuses.ChangeRequest.Closed;
        var changeRequestInProgress = workItemStatuses.ChangeRequest.InProgress;
        var changeRequestOnHold = workItemStatuses.ChangeRequest.OnHold;
        var changeRequestCancelled = workItemStatuses.ChangeRequest.Cancelled;
        var changeRequestSubmitted = workItemStatuses.ChangeRequest.Submitted;
        var changeRequestCompleted = workItemStatuses.ChangeRequest.Completed;
        var problemResolved = workItemStatuses.Problem.Resolved;
        var problemClosed = workItemStatuses.Problem.Closed;
        var releaseRecordClosed = workItemStatuses.ReleaseRecord.Closed;
        var releaseRecordCancelled = workItemStatuses.ReleaseRecord.Cancelled;
        var releaseRecordCompleted = workItemStatuses.ReleaseRecord.Completed;
        var releaseRecordFailed = workItemStatuses.ReleaseRecord.Failed;
        var releaseRecordEditing = workItemStatuses.ReleaseRecord.Editing;
        var releaseRecordOnHold = workItemStatuses.ReleaseRecord.OnHold;
        var releaseRecordInProgress = workItemStatuses.ReleaseRecord.InProgress;

        //define change rules and states
        var changeRules = new Array();

        /*ServiceRequest*/
        changeRules['ServiceRequest'] = new Array();

        changeRules['ServiceRequest'][serviceRequestSubmitted] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: serviceRequestCompleted },
                { field: "Id", operator: "eq", value: serviceRequestSubmitted }
            ]
        };

        changeRules['ServiceRequest'][serviceRequestInProgress] = {
            logic: "or",
            filters: [
                { field: "Id", operator: "eq", value: serviceRequestCancelled },
                { field: "Id", operator: "eq", value: serviceRequestInProgress },
                { field: "Id", operator: "eq", value: serviceRequestOnHold }
            ]
        };

        changeRules['ServiceRequest'][serviceRequestOnHold] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: serviceRequestOnHold },
                { field: "Id", operator: "eq", value: serviceRequestCancelled },
                { field: "Id", operator: "eq", value: serviceRequestInProgress }
            ]
        };

        changeRules['ServiceRequest'][serviceRequestFailed] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: serviceRequestFailed },
                { field: "Id", operator: "eq", value: serviceRequestClosed }
            ]
        };

        changeRules['ServiceRequest'][serviceRequestCancelled] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: serviceRequestCancelled },
                { field: "Id", operator: "eq", value: serviceRequestClosed }
            ]
        };

        changeRules['ServiceRequest'][serviceRequestCompleted] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: serviceRequestCompleted },
                { field: "Id", operator: "eq", value: serviceRequestClosed }
            ]
        };

        /*END ServiceRequest*/


        /*Release Record*/
        changeRules['ReleaseRecord'] = new Array();

        changeRules['ReleaseRecord'][releaseRecordInProgress] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: releaseRecordCancelled },
                { field: "Id", operator: "eq", value: releaseRecordEditing },
                { field: "Id", operator: "eq", value: releaseRecordInProgress },
                { field: "Id", operator: "eq", value: releaseRecordOnHold }
            ]
        };

        changeRules['ReleaseRecord'][releaseRecordEditing] = {
            logic: "or",
            filters: [
                { field: "Id", operator: "eq", value: releaseRecordCancelled },
                { field: "Id", operator: "eq", value: releaseRecordEditing }
            ]
        };

        changeRules['ReleaseRecord'][releaseRecordOnHold] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: releaseRecordCancelled },
                { field: "Id", operator: "eq", value: releaseRecordEditing },
                { field: "Id", operator: "eq", value: releaseRecordInProgress },
                { field: "Id", operator: "eq", value: releaseRecordOnHold }
            ]
        };

        changeRules['ReleaseRecord'][releaseRecordFailed] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: releaseRecordEditing },
                { field: "Id", operator: "eq", value: releaseRecordFailed },
                { field: "Id", operator: "eq", value: releaseRecordClosed }
            ]
        };

        changeRules['ReleaseRecord'][releaseRecordCancelled] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: releaseRecordEditing },
                { field: "Id", operator: "eq", value: releaseRecordCancelled },
                { field: "Id", operator: "eq", value: releaseRecordClosed }
            ]
        };

        changeRules['ReleaseRecord'][releaseRecordCompleted] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: releaseRecordEditing },
                { field: "Id", operator: "eq", value: releaseRecordClosed },
                { field: "Id", operator: "eq", value: releaseRecordCompleted }
            ]
        };

        /*END Release Record*/


        /*Change Request*/
        changeRules['ChangeRequest'] = new Array();

        changeRules['ChangeRequest'][changeRequestSubmitted] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: changeRequestCompleted },
                { field: "Id", operator: "eq", value: changeRequestSubmitted }
            ]
        };

        changeRules['ChangeRequest'][changeRequestInProgress] = {
            logic: "or",
            filters: [
                { field: "Id", operator: "eq", value: changeRequestCancelled },
                { field: "Id", operator: "eq", value: changeRequestInProgress },
                { field: "Id", operator: "eq", value: changeRequestOnHold }
            ]
        };

        changeRules['ChangeRequest'][changeRequestOnHold] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: changeRequestOnHold },
                { field: "Id", operator: "eq", value: changeRequestCancelled },
                { field: "Id", operator: "eq", value: changeRequestInProgress }
            ]
        };

        changeRules['ChangeRequest'][changeRequestFailed] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: changeRequestFailed },
                { field: "Id", operator: "eq", value: changeRequestClosed }
            ]
        };

        changeRules['ChangeRequest'][changeRequestCancelled] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: changeRequestCancelled },
                { field: "Id", operator: "eq", value: changeRequestClosed }
            ]
        };

        changeRules['ChangeRequest'][changeRequestCompleted] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: changeRequestCompleted },
                { field: "Id", operator: "eq", value: changeRequestClosed }
            ]
        };
        /*END Change Request*/

        /*Incident*/
        changeRules['Incident'] = new Array();

        changeRules['Incident'][incidentActive] = {
            field: "Id",
            operator: "neq",
            value: incidentClosed
        };

        changeRules['Incident'][incidentActivePending] = {
            field: "Id",
            operator: "neq",
            value: incidentClosed
        };

        changeRules['Incident'][incidentResolved] = {
            logic: 'or',
            filters: [
                { field: "Id", operator: "eq", value: incidentActive },
                { field: "Id", operator: "eq", value: incidentClosed }
            ]
        };

        /*END Incident*/

        /*Problem*/
        changeRules['Problem'] = new Array();
        /*END Problem*/


        return changeRules;
    }
}

app.lib = new app.lib;

//TODO put in it's own space, user require, module, etc
app.custom = function () {
    var that = this;
    this.formTasks = { //an odject to handle custom assigned from tasks
        tasks: [],
        add: function (type, label, func) {
            if (typeof (this.tasks[type]) == 'undefined') {
                this.tasks[type] = [];
            }

            this.tasks[type].push({ label: label, func: func });
            return this.tasks;
        },
        get: function (type) {
            return this.tasks[type];
        }
    }
    this.actionMethod = { //an odject to handle custom assigned from tasks
        viewModel: [],
        add: function (type, index, func) {
            if (typeof (this.viewModel[type]) == 'undefined') {
                this.viewModel[type] = [];
            }

            this.viewModel[type].push({ index: index, func: func });
            return this.viewModel;
        },
        get: function (type) {
            return this.viewModel[type];
        }
    }
}
app.custom = new app.custom;


//TODO move to own space too.
app.gridUtils = function () {
    var self = this;
    self.GridSubType = null;
    self.denoteAppliedFilters = function (grid, currentState) {
        var gridHeaders = grid.thead.find("th[data-field]");
        var filter = grid.dataSource.filter();
        grid.thead.find(".k-header-column-menu.k-state-active").removeClass("k-state-active");

        if (filter) {
            var filteredMembers = {};
            self.setFilteredMembers(filter, filteredMembers);
            gridHeaders.each(function () {
                var cell = $(this);
                var filtered = filteredMembers[cell.data("field")];
                if (filtered) {
                    if (cell.find(".k-header-column-menu").find(".fa-filter").length <= 0) {
                        cell.find(".k-header-column-menu").append("<i class='fa fa-filter'></i>");
                    }
                }
            });
        } else {
            //no filters, need to make sure the filter icon is not in the col headers
            gridHeaders.each(function () {
                var cell = $(this);
                if (cell.find(".k-header-column-menu").find(".fa-filter").length > 0) {
                    cell.find(".k-header-column-menu").find('.fa-filter').remove();
                }
            });
        }

        // stuff that we have to do to make sure we have the filter icons only on filtered columns
        if (currentState.filter && filter) {
            // just want the col names as arrays so we can get the diff
            var oldFilteredColumns = _.pluck(currentState.filter.filters, 'field');
            var newFilteredColumns = _.pluck(filter.filters, 'field');
            var filtersToRemove = _.difference(oldFilteredColumns, newFilteredColumns);

            _.each(filtersToRemove, function (removeMe) {
                _.each(gridHeaders, function (col) {
                    var cell = $(col);
                    if (cell.data("field") == removeMe) {
                        if (cell.find(".k-header-column-menu").find(".fa-filter").length > 0) {
                            cell.find(".k-header-column-menu").find('.fa-filter').remove();
                        }
                    }
                });
            });
        }
    };

    self.savedState = {
        updateSelectedRows: function (gridId, grid) {
            var currentState = app.gridUtils.savedState.getCurrentState(gridId);

            var selectedIds = grid.select().map(function () {
                return grid.dataItem($(this)).Id;
            }).toArray();

            currentState.selectedRows = selectedIds;
            app.gridUtils.savedState.setSavedState(gridId, currentState);
        },
        setSavedState: function (gridId, stateObj) {
            app.storage.gridStates.set('state_' + gridId, JSON.stringify(stateObj));
        },
        removeSavedState: function (gridId) {
            app.storage.gridStates.remove('state_' + gridId);
        },
        getCurrentState: function (gridId) {
            return app.lib.tryParseJSON(app.storage.gridStates.get('state_' + gridId));
        }
    }

    self.setDashboardGridState = function (gridId, grid, dataSource, currentState) {
        if (grid.options.noState) {
            return;
        }

        //only set up currentState if not present
        if (!currentState) {
            currentState = {
                columns: grid.columns,
                page: dataSource.page() || dataSource.options.page,
                pageSize: dataSource.pageSize() || dataSource.options.pageSize,
                sort: dataSource.sort(),
                group: dataSource.group(),
                filter: dataSource.filter()
            };

            if (currentState.columns == undefined) {
                currentState.columns = grid.columns;
            }
            else {
                grid.columns = currentState.columns;
            }

            if (currentState.columns == undefined) {
                currentState.columns = grid.columns;
            }
            else {
                grid.columns = currentState.columns;
            }
        }
        
        //save
        app.gridUtils.savedState.setSavedState(gridId, currentState);

        //set
        if (currentState.selectedRows) {
            _.each(currentState.selectedRows, function (selection) {
                var item = _.findWhere(grid.dataItems(), { Id: selection });
                if (item) {
                    var row = grid.tbody.find('[data-uid=' + item.uid + ']');
                    row.addClass('k-state-selected');
                    row.find('.multi-select-checkbox').addClass('fa-check-square-o');
                    row.find('.multi-select-checkbox').removeClass('fa-square-o');
                }
            });

            if (currentState.selectedRows.length === 0) {
                grid.table.find('.multi-select-checkbox').hide();
            }
        } else {
            grid.table.find('.multi-select-checkbox').hide();
        }
    };

    self.setGridStatePersistence = function (gridId, grid, dataSource, currentState) {
        if (grid.options.noState) {
            return;
        }

        //setup
        if (currentState) {
            if (currentState.columns == undefined || currentState.columns.length <= 0) {
                currentState.columns = grid.columns;
            }
            currentState.page = dataSource.page() || dataSource.options.page;
            currentState.pageSize = dataSource.pageSize() || dataSource.options.pageSize;
            currentState.sort = dataSource.sort();
            currentState.group = dataSource.group();
            currentState.filter = dataSource.filter();
        } else {
            currentState = {
                columns: grid.columns,
                page: dataSource.page() || dataSource.options.page,
                pageSize: dataSource.pageSize() || dataSource.options.pageSize,
                sort: dataSource.sort(),
                group: dataSource.group(),
                filter: dataSource.filter()
            }
        }

        //save
        app.gridUtils.savedState.setSavedState(gridId, currentState);

        //set
        if (currentState.selectedRows) {
            _.each(currentState.selectedRows, function (selection) {
                var item = _.findWhere(grid.dataItems(), { Id: selection });
                if (item) {
                    var row = grid.tbody.find('[data-uid=' + item.uid + ']');
                    row.addClass('k-state-selected');
                    row.find('.multi-select-checkbox').addClass('fa-check-square-o');
                    row.find('.multi-select-checkbox').removeClass('fa-square-o');
                }
            });

            if (currentState.selectedRows.length === 0) {
                grid.table.find('.multi-select-checkbox').hide();
            }
        } else {
            grid.table.find('.multi-select-checkbox').hide();
        }
    };

    self.setFilteredMembers = function (filter, members) {
        if (filter.filters) {
            for (var i = 0; i < filter.filters.length; i++) {
                self.setFilteredMembers(filter.filters[i], members);
            }
        } else {
            members[filter.field] = true;
        }
    };

    self.initRowClickHandling = function (gridId, grid, rowClickFunc) {
        var rowEle =
                    $('#' + gridId + " td.grid-highlight-column, #" + gridId + " td.grid-highlight-column-last, #" + gridId + " td.grid-highlight-column-title").exists() ||
                    $('#' + gridId + ' td').exists();
        
        if (rowEle) {
            rowEle.click(function () {
                var row = $(this).closest("tr");
                rowClickFunc(row, grid);
            });
            //do the SLO stuff
            $('#' + gridId + " .slo-grid-container").each(function () {
                var sloPart = $(this);
                SLO.CreateSLOToGrid(sloPart, true);
                SLO.SLOHover(sloPart);
            });
            //remove/hide icon if it is not a parent
            $(".grid-parent-wi-column").each(function () {
                var img = $(this);
                if (img.attr('src') == "") {
                    img.remove();
                }
            });
        }
    };

    self.getLinkUrl = function (data, gridType, bParentLink) {
        var fwdLocation = false;
        //get grid row data type
        var gridRow = data;
        var objectId = gridRow.Id;
        var type;
        var isParentLink = bParentLink;

        //determines type which is used to determine forwarding location and ids needed
        if (!_.isUndefined(gridRow.WorkItemType)) {
            type = gridRow.WorkItemType;
            if (gridRow.WorkItemType == "Activity") {
                type = gridRow.WorkItemTypeClass;
            }

            setDefaultRoute(type);
        } else {
            switch (gridType) {
                case "WarrantyContract":
                    fwdLocation = "/AssetManagement/Contract/Warranty/Edit/" + gridRow.BaseId;
                    break;
                case "LeaseContract":
                    fwdLocation = "/AssetManagement/Contract/Lease/Edit/" + gridRow.BaseId;
                    break;
                case "SupportAndMaintenanceContract":
                    fwdLocation = "/AssetManagement/Contract/SupportandMaintenance/Edit/" + gridRow.BaseId;
                    break;
                case "HardwareAsset":
                    fwdLocation = "/AssetManagement/HardwareAsset/Edit/" + gridRow.BaseId;
                    break;
                case "RequestOffering":
                    fwdLocation = "/ServiceCatalog/RequestOffering/" + gridRow.Id + ',' + gridRow.ServiceInfo.Id;
                    break;
                case "KnowledgeArticle":
                    fwdLocation = "/KnowledgeBase/View/" + gridRow.ArticleId + '?seletedTab=enduser';
                    break;
                case "CostCenter":
                    fwdLocation = "/AssetManagement/Administration/CostCenter/Edit/" + gridRow.BaseId;
                    break;
                case "Location":
                    fwdLocation = "/AssetManagement/Administration/Location/Edit/" + gridRow.BaseId;
                    break;
                case "NoticeEvent":
                    fwdLocation = "/AssetManagement/Administration/NoticeEvent/Edit/" + gridRow.BaseId;
                    break;
                case "Organization":
                    fwdLocation = "/AssetManagement/Administration/Organization/Edit/" + gridRow.BaseId;
                    break;
                case "Standard":
                    fwdLocation = "/AssetManagement/Administration/Standard/Edit/" + gridRow.BaseId;
                    break;
                case "Subnet":
                    fwdLocation = "/AssetManagement/Administration/Subnet/Edit/" + gridRow.BaseId;
                    break;
                case "Vendor":
                    fwdLocation = "/AssetManagement/Administration/Vendor/Edit/" + gridRow.BaseId;
                    break;
                case "CatalogItem":
                    fwdLocation = "/AssetManagement/Administration/CatalogItem/Edit/" + gridRow.BaseId;
                    break;
                case "License":
                    fwdLocation = "/AssetManagement/Administration/License/Edit/" + gridRow.BaseId;
                    break;
                case "Licence":
                    fwdLocation = "/AssetManagement/Administration/License/Edit/" + gridRow.BaseId;
                    break;
                case "SoftwareAsset":
                    fwdLocation = "/AssetManagement/SoftwareAsset/Edit/" + gridRow.BaseId;
                    break;
                case "PurchaseOrder":
                    fwdLocation = "/AssetManagement/Administration/PurchaseOrder/Edit/" + gridRow.BaseId;
                    break;
                case "Purchase":
                    fwdLocation = "/AssetManagement/Administration/Purchase/Edit/" + gridRow.BaseId;
                    break;
                case "Invoice":
                    fwdLocation = "/AssetManagement/Administration/Invoice/Edit/" + gridRow.BaseId;
                    break;
                case "Consumable":
                    fwdLocation = "/AssetManagement/Administration/Consumables/Edit/" + gridRow.BaseId;
                    break;
                case "Announcement":
                    fwdLocation = "/Administration/Announcement/Edit/" + gridRow.Id;
                    break;
                case "EditableKnowledgeArticle":
                    fwdLocation = "/KnowledgeBase/View/" + gridRow.ArticleId;
                    break;
                default:
                    return false;
            }
        }

        function setDefaultRoute(itemType) {
            //default forward location definitions for all current grids.
            if (gridRow.WorkItemType == "Activity") {
                $.get("/grid/GetActivityParentWorkItem", { id: gridRow.BaseId }, function (data) {
                    gridRow.ParentWorkItemType = data.ParentWorkItemType;
                    gridRow.ParentWorkItemId = data.ParentWorkItemId;
                    getActivityParentWorkItem(itemType);
                });
            } else {
                getActivityParentWorkItem(itemType);
            }
        }

        function getActivityParentWorkItem(itemType) {
            if (itemType.indexOf("System.WorkItem") > -1) {
                //It is a work Item
                fwdLocation = '/' + itemType.split('.').pop() + '/Edit/' + objectId + '/';
                if (itemType.indexOf("Activity") > -1) {
                    //if it is from my work->approval page, redirect to RA approval form
                    if (!_.isNull(self.GridSubType) && (_.isUndefined(isParentLink) || !isParentLink)) {
                        var approvalUrl = "";
                        switch (self.GridSubType) {
                            case "myapprovals":
                                approvalUrl = "/ReviewActivity/Approval/" + objectId;
                                break;
                            case "mymanualactivities":
                                approvalUrl = "/ManualActivity/Complete/" + objectId;
                                break;
                            default:
                                approvalUrl = "/Activity/Edit/" + objectId;
                                break;
                        }
                        fwdLocation = approvalUrl;
                    } else {
                        //It is a work item activity
                        fwdLocation = '/Activity/Edit/' + objectId;
                    }
                }
            }
        }

        return fwdLocation;
    };
    self.initDashboardRowClickHandling = function (gridId, grid) {
        //set up click for highlight columns
        var highlightCols = $("[adf-grid-state-id=" + gridId + "] td.grid-highlight-column");
        highlightCols.click(function () {
            var selectedData = grid.dataItem(grid.select());
            var forwardLink = '';
            if (!_.isUndefined(selectedData) && !_.isUndefined(selectedData.WorkItemType)) {
                var workItemType = selectedData.WorkItemType.split('.').pop();
                forwardLink= "/" + workItemType + "/Edit/" + selectedData.Id;

                //for activities, use parentworkitem type and id
                if (workItemType.indexOf("Activity") > -1) {
                    forwardLink = "/" + selectedData.ParentWorkItemType + "/Edit/" + selectedData.ParentWorkItemId + "?activityId=" + selectedData.Id + "&tab=activity";
                }
            } else {
                forwardLink = $(this).attr('href');
            }

            window.location.href = forwardLink;
        });
    };

    self.handleEmptyResults = function (grid, dataSource, currentState) {
        var colCount = grid.columns.length;
        var noResultsMessage = localization["NoResults"];
        // If there are no results place an indicator row
        if (dataSource._view.length == 0) {
            grid.tbody.append('<tr class="kendo-data-row"><td colspan="' + colCount + '">' + noResultsMessage + '</td></tr>');

            //added to navigate back to page 1 after grid search
            if (grid.dataSource.page() != 1) {
                currentState.page = 1;
                if (!grid.options.noState) {
                    dataSource.query(currentState);
                }
            }
        }
    };

    self.saveColumnState = function (gridId, grid, isDirective) {
        try {
            if (grid.options.noState) {
                return;
            }
            var currentState = app.gridUtils.savedState.getCurrentState(gridId);
            var dataSource = grid.dataSource;

            currentState.columns = grid.columns;
            currentState.page = dataSource.page() || dataSource.options.page;
            currentState.pageSize = dataSource.pageSize() || dataSource.options.pageSize;
            currentState.sort = dataSource.sort();
            currentState.group = dataSource.group();
            currentState.filter = dataSource.filter();

            app.gridUtils.savedState.setSavedState(gridId, currentState);

            //don't want to requery for angular directives
            if (!isDirective) {
                grid.dataSource.query(currentState);
            }
        } catch (e)
        {
            console.log("error", e);
        }
    }


    self.setDataSourceOverrides = function (vm) {
        if (_.isUndefined(vm.grid.options)) {
            return;
        }
        //check if paging/sorting/filtering is off
        var opts = vm.grid.options;
        if (!_.isUndefined(opts.pageable)) {
            if (opts.pageable != false) {
                vm.dataSource.pageSize = 20;
                vm.dataSource.page = 1;
                vm.dataSource.total = 0;
                vm.dataSource.serverPaging = true;
            }
        }
        if (!_.isUndefined(opts.filterable)) {
            if (opts.filterable != false) {
                vm.dataSource.serverFiltering = true;
            }
        }
        if (!_.isUndefined(opts.sortable)) {
            if (opts.sortable != false) {
                vm.dataSource.serverSorting = true;
            }
        }
        if (!_.isUndefined(opts.groupable)) {
            if (opts.groupable != false) {
                vm.dataSource.serverGrouping = true;
            }
        }

        //override to run everything local
        if (!_.isUndefined(opts.runLocal)) {
            if (opts.groupable != false) {
                vm.dataSource.serverPaging = false;
                vm.dataSource.serverFiltering = false;
                vm.dataSource.serverSorting = false;
                vm.dataSource.serverGrouping = false;
            }
        }
    };

    self.applyLocalizationDataSourceConfig = function (gridId, vm) {

        vm.dataSource = {
            transport: {
                prefix: "",
                parameterMap: function (data, operation) {
                    if (operation === "update" || operation === "create" || operation === "destroy") {
                        _.each(data.models, function (row) {
                            row.Locale = store.session.get('localizationGridLocale');
                        });
                        if (operation === "create" || operation === "destroy") {
                            //create and delete are not batch, so just set the first/only item as the model
                            data.model = data.models[0];
                        }
                        return JSON.stringify(data);
                    }
                    return data;
                }
            },
            batch: true,
            schema: {
                data: "Data",
                total: "Total",
                errors: "Errors",
                model: {
                    id: "Id",
                    fields: {}
                }
            }
        };

        //setup endpoints
        _.each(vm.grid.dataSourceEndpoints, function (endpoint, key) {
            if (key == "create") {
                vm.grid.dataSourceEndpoints[key].complete = function (jqXhr, textStatus) {
                    app.lib.mask.remove();
                    if (textStatus == "success") {
                        var grid = $('#' + gridId).data('kendoGrid');
                        grid.refresh();
                        app.lib.message.add(localization.ChangesApplied, "success");
                    } else {
                        app.lib.message.add(localization.ErrorOccured, "danger");
                    }
                    app.lib.message.show();
                }
            }

            if (key == "update" || key == "destroy") {
                vm.grid.dataSourceEndpoints[key].complete = function (jqXhr, textStatus) {
                    app.lib.mask.remove();
                    if (textStatus == "success") {
                        app.lib.message.add(localization.ChangesApplied, "success");
                    } else {
                        app.lib.message.add(localization.ErrorOccured, "danger");
                    }
                    app.lib.message.show();
                }
            }

            if (key == "read" && vm.grid.GridType == "Localization") {
                var endpointDefaults = endpoint.data;
                endpoint.originalConfigData = endpoint.data;
                endpoint.data = function () {
                    var myGrid = $('#' + gridId).data('kendoGrid');

                    if (myGrid) {
                        var comboEle = $(myGrid.element).find("#locale").data('kendoDropDownList');
                        var checkboxEle = $(myGrid.element).find("#showAlreadyTranslated");
                        if (comboEle && checkboxEle) {
                            var locale = comboEle.value();
                            if (locale.length == 0) {
                                locale = session.user.LanguageCode;
                            }
                            store.session.set("localizationGridLocale", locale);
                            return {
                                locale: locale, showAlreadyTranslated: checkboxEle.prop('checked')
                            }
                        }


                    }
                    store.session.set("localizationGridLocale", session.user.LanguageCode);
                    //return defaults
                    return { "locale": session.user.LanguageCode, "showAlreadyTranslated": endpointDefaults.showAlreadyTranslated }
                }
            }
            vm.dataSource.transport[key] = endpoint;
        });
    };

    self.applyKmDashboardDataSourceConfig = function (gridId, vm) {
        vm.dataSource = {
            transport: {
                parameterMap: function (data, operation) {
                    if (operation === "update") {
                        return JSON.stringify(data.models);
                    }
                    return data;
                }
            },
            batch: true,
            schema: {
                model: {
                    id: "ArticleId"
                }
            }
        };

        _.each(vm.grid.dataSourceEndpoints, function (endpoint, key) {
            if (key === "update") {
                //handle callback
                vm.grid.dataSourceEndpoints[key].complete = function (jqXhr, textStatus) {
                    app.lib.mask.remove();
                    if (textStatus == "success") {
                        app.lib.message.add(localization.ChangesApplied, "success");
                    } else {
                        app.lib.message.add(localization.ErrorOccured, "danger");
                    }
                    app.lib.message.show();
                }
            }

            vm.dataSource.transport[key] = endpoint;
        });

    };

    self.configureGenericGrid = function (gridId, vm) {
        vm.dataSource = {
            transport: {
                prefix: "",
                read: {
                    url: vm.grid.dataUrl,
                    data: function () {
                        var paramObj = {};
                        var returnObj = {};
                        var hasName = false;
                        if (!_.isUndefined(vm.grid.queryParameters)) {
                            _.each(vm.grid.queryParameters.params, function (param) {
                                if (_.isUndefined(param.valueSource)) {
                                    //no valueSource, so it is a non-updatable component
                                    paramObj[param.name] = param.value;
                                } else {
                                    switch (param.sourceType) {
                                        case "page-data":
                                            paramObj[param.name] = vm[param.valueSource];
                                            break;
                                        case "dynamic-query-selector":
                                            var otherKey = param.valueSource.substring(param.valueSource.indexOf("{{") + 2, param.valueSource.indexOf("}}"));
                                            var valSource = param.valueSource.replace('{{' + otherKey + '}}', paramObj[otherKey]);
                                            paramObj[param.name] = $(valSource).val();
                                            break;
                                        default:
                                            var paramValue = $(param.valueSource).val(); //if this is not on the dom, it will evaluate to false.
                                            if (_.isUndefined(paramValue) && param.valueSource === '#gridViewId') {
                                                //fallback to default param value of myrequests
                                                paramValue = 'myrequests';
                                            }
                                            paramObj[param.name] = paramValue;
                                    }
                                }
                            });

                            if (!_.isUndefined(vm.grid.queryParameters.name)) {
                                returnObj[vm.grid.queryParameters.name] = "";
                                hasName = true;
                            }
                            switch (vm.grid.queryParameters.type) {
                                case "stringify":
                                    if (hasName) {
                                        returnObj[vm.grid.queryParameters.name] = JSON.stringify(paramObj);
                                        return returnObj;
                                    } else {
                                        return JSON.stringify(paramObj);
                                    }
                                case "ind":
                                    if (hasName) {
                                        returnObj[vm.grid.queryParameters.name] = paramObj;
                                        return returnObj;
                                    } else {
                                        return paramObj;
                                    }
                                default:
                                    return paramObj;
                            }
                        } else {
                            return {};
                        }

                    }
                }
            },
            type: "aspnetmvc-ajax",
            schema: {
                data: "Data",
                total: "Total",
                errors: "Errors",
                model: {

                }
            }
        };
    };

    self.getApprovalLinkUrl = function (gridRow) {
        var fwdLocation = false;
        var objectId = gridRow.Id;

        switch (gridRow.WorkItemType) {
            case "System.WorkItem.Activity.ManualActivity":
                fwdLocation = "/ManualActivity/Complete/" + objectId;
                break;
            case "System.WorkItem.Activity.ReviewActivity":
                fwdLocation = "/ReviewActivity/Approval/" + objectId;
                break;
        }

        return fwdLocation;
    }

    self.handleRowHoverEvent = function (arg) {
        var icons = $(arg.sender.element[0]).find("tr td span a");
        icons.hover(function () {
            if (!$(this).hasClass("highlight-default-icon")) {
                $(this).parent().find(".highlight-default-icon i").css("color", '#a3b8c2');
            }
        });

        icons.mouseleave(function () {
            if (!$(this).hasClass("highlight-default-icon")) {
                $(this).parent().find(".highlight-default-icon i").removeAttr("style");
            }
        });
    }

}

app.gridUtils = new app.gridUtils;
