﻿var Consumable = new function () {

    var AssignedConsumableAssets
    var AssignedConsumableUsers;
    var AutoAssignmentCount;
    var ConsumableHasAssignedAssets;
    var ConsumableHasAssignedUsers;
    var currentAssignedCount;
    var txtAssignedCount;
    var allCurrentCount;
    var vm;

    this.OnChange = function (e, vm, mainContainer) {
        
        if (e.field === 'Count') {
            Consumable.CheckedIfEnabledOrDisabledAutoAssignement();
        } else if (e.field === 'Target_ConsumableHasAssignedUsers') {
            if (vm.get("CountAssignedConsumableUsers")) {
                Consumable.CheckedIfEnabledOrDisabledAutoAssignement(e);
            }
        } else if (e.field === 'Target_ConsumableHasAssignedAssets') {
            
            if (vm.get("CountAssignedConsumableAssets")) {
                Consumable.CheckedIfEnabledOrDisabledAutoAssignement(e);
            }
        }
    }

    this.Init = function (vModel) {
        vm = vModel;
        AssignedConsumableAssets = $("input[name='CountAssignedConsumableAssets']");
        AssignedConsumableUsers = $("input[name='CountAssignedConsumableUsers']");
        AutoAssignmentCount = $("input[name='AutoAssignmentCount']");
        ConsumableHasAssignedAssets = $("div[id='Target_ConsumableHasAssignedAssets']");
        ConsumableHasAssignedUsers = $("div[id='Target_ConsumableHasAssignedUsers']");
        currentAssignedCount = vm.get("AssignedCount");
        txtAssignedCount = $("input[name='AssignedCount']").data("kendoNumericTextBox");
        allCurrentCount = currentAssignedCount;

        this.CheckedIfEnabledOrDisabledAutoAssignement();
        AssignedConsumableAssets.change(function () {
            Consumable.CheckedIfEnabledOrDisabledAutoAssignement();
        });

        AssignedConsumableUsers.change(function () {
            Consumable.CheckedIfEnabledOrDisabledAutoAssignement();
        });

        AutoAssignmentCount.change(function () {
            Consumable.CheckedIfEnabledOrDisabledAutoAssignement();
        });
    }

    

    this.CheckedIfEnabledOrDisabledAutoAssignement = function (event) {
        var isNotExceeded = true;
        this.GetCount();
        var count = vm.get("Count");
        if (vm.get("CountAssignedConsumableAssets") && vm.get("AutoAssignmentCount") && count <= 0) {
            ConsumableHasAssignedAssets.find("button.k-button").attr("disabled", "");
            ConsumableHasAssignedAssets.find("a.k-button").css("visibility", "hidden");
            isNotExceeded = false;
        } else {
            ConsumableHasAssignedAssets.find("button.k-button").removeAttr("disabled");
            ConsumableHasAssignedAssets.find("a.k-button").css("visibility", "visible");
        }

        if (vm.get("CountAssignedConsumableUsers") && vm.get("AutoAssignmentCount") && count <= 0) {
            ConsumableHasAssignedUsers.find("button.k-button").attr("disabled", "");
            ConsumableHasAssignedUsers.find("a.k-button").css("visibility", "hidden");
            isNotExceeded = false;
        } else {
            ConsumableHasAssignedUsers.find("button.k-button").removeAttr("disabled");
            ConsumableHasAssignedUsers.find("a.k-button").css("visibility", "visible");
        }

        if (vm.get("CountAssignedConsumableUsers") || vm.get("CountAssignedConsumableAssets")) {
            AutoAssignmentCount.removeAttr("disabled");
        } else {
            vm.set("AutoAssignmentCount", false);
            AutoAssignmentCount.attr("disabled", "");
        }

        if (!_.isUndefined(event)) {

            if (!isNotExceeded) { //This will going to remove exceeded items added depends on available count
                var tempList = [];
                if (event.field === 'Target_ConsumableHasAssignedUsers' || e.field === 'Target_ConsumableHasAssignedAssets') {
                    tempList = vm.get(event.field);
                }

                for (var index in tempList) {
                    if (event.items[0].BaseId == tempList[index].BaseId) {
                        tempList.splice(index, 1);
                        break;
                    }
                }
            }

            vm.set("AssignedCount", allCurrentCount);
            if (vm.get("AutoAssignmentCount")) {
                if (event.action == "add") {
                    vm.set("Count", parseInt(vm.get("Count")) - 1)
                } else {
                    vm.set("Count", parseInt(vm.get("Count")) + 1)
                }
            }
            
        } 
    }

    this.GetCount = function () {
        allCurrentCount = currentAssignedCount;
        txtAssignedCount.enable(false);
        if (vm.get("CountAssignedConsumableAssets") && vm.get("CountAssignedConsumableUsers")) {
            allCurrentCount = vm.get("Target_ConsumableHasAssignedAssets").length + vm.get("Target_ConsumableHasAssignedUsers").length;
            vm.set("AssignedCount", allCurrentCount);
        } else if (vm.get("CountAssignedConsumableAssets")) {
            allCurrentCount = vm.get("Target_ConsumableHasAssignedAssets").length;
            vm.set("AssignedCount", allCurrentCount);
        } else if (vm.get("CountAssignedConsumableUsers")) {
            allCurrentCount = vm.get("Target_ConsumableHasAssignedUsers").length;
            vm.set("AssignedCount", allCurrentCount);
        } else {
            vm.set("AssignedCount", 0);
            txtAssignedCount.enable(true);
        }
    }
}
