﻿/**
STRING
**/

define(function (require) {
    var tpl = require("text!forms/fields/urlTextbox/view.html");


    var definition = {

        template: tpl,
        build: function (viewModel, node, callback) {
            
            var vm = node.vm;
            
            var view = new kendo.View();

            if (_.isUndefined(vm.view)) {
                vm.view = [];
            }
            
            vm.view.buildURLTextbox = function () {
                //build template using underscore.js so that we can interpret kendo template vars if needed
                var built = _.template(tpl);
                var regexp = new RegExp(/^((ftp|http|https?):\/\/)?([w|W]{3}\.)*?[a-zA-Z0-9\-\.]{3,}\.[a-zA-Z]{2,}(\.[a-zA-Z]{2,})?$/);
                var disabled = "urlTextboxButtonDisabled";
                var error = "input-error";
                var url = vm.get(node.PropertyName);

                var properties = {
                    Required: node.Required,
                    Disabled: node.disabled
                };
                
                $.extend(true, properties, node);
                var template = $(built(properties));
                var txtBox = template.find("input");
                var link = template.find(".urlTextboxIcon");

                var validateUrl = function () {
                    var isOk = true;
                    url = vm.get(node.PropertyName);
                    link.removeClass(disabled);
                    txtBox.removeClass(error);
                    if (url == "" || _.isNull(url)) {
                        isOk = false;
                        link.addClass(disabled);
                    } else if (!regexp.test(url)) {
                        link.addClass(disabled);
                        txtBox.addClass(error);
                        isOk = false;
                    }
                    return isOk;
                }
                validateUrl();
                vm.textChange = function (e) {
                    validateUrl();
                }

                vm.openURL = function (e) {
                    if (validateUrl()) {
                        //append protocol if does not have one
                        if (!url.match(/^ftp|http([s]?):\/\/.*/)) {
                            url = 'http://' + url;
                        }
                        var win = window.open(url, '_blank');
                        win.focus();
                    }
                };


                view = new kendo.View(template, { wrap: false, model: vm });
               
               callback(view.render());
            };
            vm.view.buildURLTextbox();
        }
    }

    return definition;

});
