﻿require.config({
    waitSeconds: 0,
    urlArgs: "v=" + session.staticFileVersion,
    baseUrl: "/Scripts/",
    paths: {
        //kendo: "kendo/js/kendo.mobile.min",
        //jquery: "jquery/jquery.min",
        text: "require/text"
    },

    shim: {
        //kendo: {
        //    deps: ['jquery'],
        //    exports: 'kendo'
        //}
    }
});

//let's let the user know that things are happening
app.lib.mask.apply();
$("body").css("cursor", "wait");
$(document).ajaxStop(function () {
    $("body").css("cursor", "auto");
});

require(["forms/headerBuilder", "forms/formBuilder", "forms/formHelper"], function (headerBuilder, formBuilder, formHelper) {


    var saveUrl = pageForm.saveUrl;
    var mainContainer = $(pageForm.container);
    var headerContainer = $('.page_bar').empty();

    var formContainer = $('<div/>').addClass("page-form");
    var dataVM = pageForm.viewModel;
   

    //add header json definition
    //since all WI have same header structure we put it in this file
    //if this changes we need to move this to all the cshtml New/Edit files
    if (pageForm.type == "userRelatedInfo") {
        pageForm.headerTemplate = {
            rows: [
                    {
                        columns: [
                            { View: "status", Class: "col-md-5 col-xs-12" },
                            { View: "spacer", ColSpan: 4 }
                        ]
                    }
            ]
        };
    } else {
        pageForm.headerTemplate = {
            rows: [
                    {
                        columns: [
                            { View: "title", ColSpan: 8 },
                            { View: "spacer", ColSpan: 4 }
                        ]
                    }
            ]
        };
    }

    var init = function () {
        /*
         * this is how we are doing some session stuff to pick what template to use. (find it in wiMain.js)
         *          setTemplateJSONFromSessionAdJSON();
         * For WIs at least the templates can vary based on AD groupd (I think).
         * For Incidents we have "Default" and "DefaultEndUser".
         * If we are not going to have different types of User Profile forms, we can likely skip 
         * this and just define it like I have. Or change the json structure. Some kind of standard
         * is being worked out on all this so we can streamline it better.
         */
        if (pageForm.type == "userRelatedInfo") {
            if (dataVM.hasAsset) {
                pageForm.formTemplate = pageForm.formTemplate["Default"];
            } else {
                pageForm.formTemplate = pageForm.formTemplate["withOutAsset"];
            }
        } else {
            pageForm.formTemplate = pageForm.formTemplate["Default"];
        }

        //add dynamic containers to main container
        //mainContainer.append(headerContainer, formContainer);
        mainContainer.append(formContainer);

        //build and add header container
        headerBuilder.build(pageForm, function (view) {
            headerContainer.append(view);
        });

        //build and add form from json definition
        formBuilder.build(pageForm, function (html) {
            formContainer.append(html);
            app.controls.apply(formContainer, { localize: true, vm: dataVM, bind: true });

            formContainer.show();

            if (pageForm.type != "userRelatedInfo") {

                // make sure we have the drawer before we try to add buttons buttons
                //if (!_.isUndefined(drawermenu)) { //stupid underscore need to move to lo-dash
                if (typeof (drawermenu) != 'undefined') {
                    createButtons();
                } else {
                    app.events.subscribe("drawerCreated", function () {
                        createButtons();
                    });
                }
            }

            app.lib.handleMessages();

            //manage dirty
            formHelper.manageDirty(dataVM);
        });

        //let them in
        app.lib.mask.remove();
    }

    // Form Buttons
    var createButtons = function () {


        // Save Failure
        var saveFailure = function (exceptionMessage) {
            if (exceptionMessage == localization.RequiredFieldsErrorMessage) {
                app.lib.message.add(exceptionMessage, "danger");
            } else {
                //fallback to generic message
                app.lib.message.add(localization.PleaseCorrectErrors, "danger");
            }
            app.lib.message.show();
        }
        // Save Button
        drawermenu.addButton(localization.Save, "fa fa-check", function () {

            save(function (data) {
                data = eval("(" + data + ")");

                app.lib.message.add(data.data, "success");
                location = "/Settings/User/UserProfile/";
                app.clearAllLocalStorage();
                // we need this to force terminate the warning window bacasue of app.clearAllLocalStorage() function.
                app.sessionTimeout.hideWarningPopup();
                store.set("cireson_last_read_announcement", new Date().toISOString());//it should be stored on local storage.
            }, saveFailure);
        });



        // Apply Button
        drawermenu.addButton(localization.Apply, "fa fa-pencil", function () {

            save(function (data) {
                
                refreshButtons();
                $(".k-overlay").hide();
                app.lib.message.show();
                setTimeout(function () {
                    $('html, body').animate({
                        scrollTop: 0
                    }, 300);
                    app.lib.mask.remove();
                    location = "/Settings/User/UserProfile/";
                    app.clearAllLocalStorage();
                    // we need this to force terminate the warning window bacasue of app.clearAllLocalStorage() function.
                    app.sessionTimeout.hideWarningPopup();
                    store.set("cireson_last_read_announcement", new Date().toISOString());//it should be stored on local storage.
                }, 100);
            }, saveFailure);
        });
        // Cancel Button
        drawermenu.addButton(localization.Cancel, "fa fa-times", function () {
            if (dataVM.get("isDirty")) {
                $.when(kendo.ui.ExtOkCancelDialog.show({
                    title: localization.Warning,
                    message: localization.UnsavedDataMessage,
                    icon: "fa fa-exclamation"
                })
                ).done(function (response) {
                    if (response.button === "ok") {
                        //make the form clean so we don't trigger onbeforeunload
                        dataVM.set("isDirty", false);

                        location.href = "/Settings/User/UserProfile/";
                    }
                });
            } else {
                location.href = "/Settings/User/UserProfile/";
            }
        });


    }

    var refreshButtons = function () {
        if (pageForm.viewModel.IsNew) {
            $("#drawer-taskbar").html("");
            pageForm.viewModel.IsNew = false;
            createButtons();
        }
    }

    // Ajax Save Method (to be moved)
    var save = function (success, failure) {
        //ensure all values inputted have been bound to VM
        $(".page_content *").blur();

        var valid = true;
        formContainer.find(".form-group").removeClass("has-error");
        formContainer.find("[required]").each(function () {
            var jqEle = $(this);
            var nodeName = jqEle[0].nodeName.toLowerCase();
            if (nodeName != "input" && nodeName != "textarea") {
                jqEle = jqEle.find("input");
            }
            if (jqEle.val() == "") {
                valid = false;
                jqEle.parents(".form-group").addClass("has-error");
            }
        });
        if (!valid) {
            failure(localization.RequiredFieldsErrorMessage);
            return;
        }
        app.lib.mask.apply();


        var postData = encodeURIComponent(JSON.stringify({
            isDirty: true,
            current: dataVM.toJSON(),
            original: pageForm.jsonRaw
        }));

        $.ajax({
            type: 'POST',
            dataType: 'text',
            url: saveUrl,
            data: "formJson=" + postData,
            success: function (data, status, xhr) {
                //make the form clean so we don't trigger onbeforeunload
                dataVM.set("isDirty", false);

                if (data.search('loginForm') < 0) { // Logged out check                   
                    success(data);
                } else {
                    //session expired
                    window.location = "/Login/Login?ReturnUrl=" + window.location.pathname;
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                failure();
                console && app.lib.log(localization.RequestFailed);
                app.lib.log(thrownError);

                var jsonRsp = xhr.responseText;
                app.lib.log(jsonRsp);

                var errorMsg = localization.RequestFailed;
                if (jsonRsp.exception && jsonRsp.exception.length > 0) {
                    errorMsg = jsonRsp.exception;
                }

                kendo.ui.ExtAlertDialog.show({
                    title: localization.ErrorDescription,
                    message: errorMsg,
                    icon: "fa fa-exclamation"
                });
            },
            processData: false,
            async: false
        });
    }

    init();


});
