﻿require.config({
    waitSeconds: 0,
    urlArgs: "v=" + session.staticFileVersion,
    baseUrl: "/Scripts/",
    paths: {
        //kendo: "kendo/js/kendo.mobile.min",
        //jquery: "jquery/jquery.min",
        text: "require/text"
    },

    shim: {
        //kendo: {
        //    deps: ['jquery'],
        //    exports: 'kendo'
        //}
    }
});

//let's let the user know that things are happening
app.lib.mask.apply();
$("body").css("cursor", "wait");
$(document).ajaxStop(function () {
    $("body").css("cursor", "auto");
});

require(["forms/taskBuilder", "forms/headerBuilder", "forms/formBuilder", "forms/formHelper"], function (taskBuilder, headerBuilder, formBuilder, formHelper, messagesStructure) {
    
    var saveUrl = pageForm.saveUrl;
    var mainContainer = $(pageForm.container);
    var headerContainer = $('.page_bar').empty(); //use new page header div, just clear it out before adding things
    var formContainer = $('<div/>').addClass("page-form");
    var taskContainer = $('<div data-bind="affix:{top:auto}" class="task-panel task-panel-narrow"></div>');
    var dataVM = pageForm.viewModel;
    var current;

    //add header json definition
    //since all WI have same header structure we put it in this file
    //if this changes we need to move this to all the cshtml New/Edit files
    pageForm.headerTemplate = {
        rows: [
                {
                    columns: [
                        { View: "approval", Class: "col-md-12 col-xs-12" },
                    ]
                }
        ]
    };

    pageForm.taskTemplate = {};
    pageForm.formTemplate = {};

    //construct userinputs to json format
    

    var init = function ()
    {
        //add dynamic containers to main container
        mainContainer.append(formContainer);

        mainContainer.before(taskContainer);
        taskBuilder.build(pageForm, function (view) {
            taskContainer.append(view);
        });

        //build and add header container
        headerBuilder.build(pageForm, function (view) {
            headerContainer.append(view);
        });

        //build and add form from json definition
        formBuilder.build(pageForm, function (html) {
            //get the topmost parent workitem
            var getActivityParentWorkItem = function (activityId) {
                return $.ajax({
                    type: 'GET',
                    dataType: 'json',
                    url: "/Search/GetActivityParentWorkItem",
                    data: {
                        id: activityId
                    }
                });
            }

            //get the topmost parent workitem details
            var getParentWorkItem = function(parentWorkItem) {
                return $.ajax({
                    type: 'GET',
                    dataType: 'json',
                    url: "/Search/GetObjectProjectionByWorkItemID",
                    data: {
                        workitemId: parentWorkItem.ParentWorkItemId,
                        workitemType: parentWorkItem.ParentWorkItemType
                    }
                });
            }

            getActivityParentWorkItem(dataVM.BaseId).then(function (data) {
                getParentWorkItem(data).then(function (result) {
                    //set parent workitem
                    dataVM.set("ParentWorkItem", result);
                    //dataVM.set("ApprovalModel", pageForm.view.approvalModel);
                    //if (dataVM."dae75d12-89ac-a8d8-4fe3-516c2a6a26f7")


                    //add edit link urls to viewModel
                    dataVM.ActivityEditUrl = app.lib.getLinkUrl(dataVM.ClassName.split(".").pop(), dataVM.Id);
                    dataVM.WorkItemEditUrl = app.lib.getLinkUrl(dataVM.ParentWorkItem.ClassName.split(".").pop(), dataVM.ParentWorkItem.Id);

                    formContainer.append(html);
                    app.controls.apply(formContainer, { localize: true, vm: dataVM, bind: true });
                    kendo.bind($("#form"), dataVM);

                    //build and add user input panel bar 
                    var userInputs = [];
                    var prop = (!_.isNull(dataVM.ParentWorkItem.UserInput)) ? dataVM.ParentWorkItem.UserInput.UserInputs.UserInput : null;
                    if (!_.isUndefined(prop) && !_.isNull(prop)) {
                        if (prop.length) {
                            userInputs = prop;
                        } else if (_.isObject(prop)) {
                            userInputs.push(prop);
                        }
                    }

                    //format display text for dates, enums, and query results
                    _.each(userInputs, function (userInput) {
                        switch (userInput.Type) {
                            case "datetime":
                                userInput.Answer = app.lib.getFormattedLocalDateTime(userInput.Answer);
                                break;
                            case "enum":
                                app.lib.getEnumDisplayName(userInput.Answer).success(function (data) {
                                    userInput.Answer = data;
                                });
                                break;
                            case "System.SupportingItem.PortalControl.InstancePicker":
                                userInput.Answer = app.lib.getQueryResultDisplayText(userInput);
                                break;
                            default:
                                break;
                        }
                    });

                    var userInputViewModel = new kendo.observable({
                        Count: userInputs.length,
                        UserInputs: userInputs
                    });

                    var template = kendo.template($("#panelbar-template").html());
                    var result = template(userInputViewModel);
                    $(".user-input-panel").html(result);
                });
            });
            

            //build out the review status section 
            if (!_.isUndefined(dataVM.Reviewer) && dataVM.Reviewer.length > 0) {
                var notYetVoted = "dae75d12-89ac-a8d8-4fe3-516c2a6a26f7";
                var review = _.find(pageForm.viewModel.Reviewer, function (reviewItem) {
                    if (_.isUndefined(reviewItem.User)) {
                        return null;
                    }
                    var group = _.find(pageForm.userGroup, function (group) {
                        return reviewItem.User.BaseId == group.Id;
                    });

                    return !_.isUndefined(reviewItem.User) && (reviewItem.User.BaseId == session.user.Id || !_.isUndefined(group));
                });

                if (!review) return;

                var bIsReviewed = review.Decision.Id !== notYetVoted;
                
                dataVM.set("isReviewed", bIsReviewed);
                dataVM.set("reviewDetails", {
                    fullDetails: review,
                    decisionDate: kendo.toString(new Date(review.DecisionDate), "g")
                });
            }

            formContainer.show();
        });


        var $taskPanel = $('.task-panel').first();
        $taskPanel.affix({ offset: { top: $taskPanel[0].getBoundingClientRect().top - 84 } });

        //let them in
        app.lib.mask.remove();
    }

    // Form Buttons
    var createButtons = function () {
        // Save Failure
        var saveFailure = function (exceptionMessage) {
            if (exceptionMessage == localization.RequiredFieldsErrorMessage) {
                app.lib.message.add(exceptionMessage, "danger");
            } else {
                //fallback to generic message
                app.lib.message.add(localization.PleaseCorrectErrors, "danger");
            }
            app.lib.message.show();
        }
        // Save Button
        drawermenu.addButton(localization.Save, "fa fa-check", function () {
            if (!app.lib.CheckedStartAndEndDate("StartDate", "EndDate", localization.StartDateShouldNotGreaterEndDate)) {
                return;
            }
            save(function (data) {
                app.lib.message.add(localization[pageForm.type] + " " + localization.Saved + "&nbsp;&nbsp;<strong>" + getDisplayName() + "</strong>", "success");
                
                app.lib.gotoFormReturnUrl();
                return;

            }, saveFailure);
        });



        // Apply Button
        drawermenu.addButton(localization.Apply, "fa fa-pencil", function () {
            if (!app.lib.CheckedStartAndEndDate("StartDate", "EndDate", localization.StartDateShouldNotGreaterEndDate)) {
                return;
            }
            save(function (data) {
                app.lib.message.add(localization.ChangesApplied, "success");
                
                location = pageForm.returnEditUrl + getObjectId();
            }, saveFailure);
        });
        // Cancel Button
        drawermenu.addButton(localization.Cancel, "fa fa-times", function () {
            if (dataVM.get("isDirty")) {
                $.when(kendo.ui.ExtOkCancelDialog.show({
                    title: localization.Warning,
                    message: localization.UnsavedDataMessage,
                    icon: "fa fa-exclamation"
                })
                ).done(function (response) {
                    if (response.button === "ok") {
                        //make sure we set the dirty flag off
                        dataVM.set("isDirty", false);

                        app.lib.gotoFormReturnUrl();
                        return;
                    }
                });
            } else {
                app.lib.gotoFormReturnUrl();
                return;
            }
        });

        if (pageForm.isNew == false) {
            drawermenu.addButton(localization.Delete, "fa fa-trash", function () {
                $.when(kendo.ui.ExtOkCancelDialog.show({
                    title: localization.Warning,
                    message: localization.DeleteAnnouncement,
                    icon: "fa fa-exclamation"
                })
               ).done(function (response) {
                   if (response.button === "ok") {
                       $.ajax({
                           type: "DELETE",
                           url: app.lib.addUrlParam(pageForm.deleteUrl, "announcementId", getObjectId()),
                           success: function () {
                               location.href = "/View/903eb5d5-fea1-4e4d-85ba-f4c386a6e054";
                           }
                       });
                   }
               });

            });
        }


    }

    var getDisplayName = function () {
        switch (pageForm.type) {
            default:
                return dataVM.Title;
        }
    }

    var getPostObject = function (postData) {
        switch (pageForm.type) {
            case "Announcement":
                var formData = postData.current;
                var announcement = {
                    Id: formData.Id,
                    Title: formData.Title,
                    Priority: formData.Priority,
                    Body: formData.Body,
                    AccessGroupId: formData.AccessGroupId,
                    StartDate: formData.StartDate,
                    EndDate: formData.EndDate,
                    Locale: session.user.LanguageCode
                }
                return JSON.stringify(announcement);
            default:
                return encodeURIComponent(JSON.stringify(postData));
        }
    }

    var getObjectId = function(){
        switch (pageForm.type) {
            case "Announcement":
                return dataVM.Id;
            default:
                return dataVM.BaseId;
        }
    }

    // Ajax Save Method (to be moved)
    var save = function (success, failure) {
        //ensure all values inputted have been bound to VM

        var valid = true;
        formContainer.find(".form-group").removeClass("has-error");
        formContainer.find("[required]").each(function () {
            var jqEle = $(this);

            var property = !_.isUndefined(jqEle.attr("data-control-bind")) ? jqEle.attr("data-control-bind") : jqEle[0].name;
            if (_.isUndefined(property) || property != "") {
                if (!_.isUndefined(jqEle[0].kendoBindingTarget) && !_.isUndefined(jqEle[0].kendoBindingTarget.options)) {
                    property = jqEle[0].kendoBindingTarget.options.propertyName;
                }
            }
            if (!_.isUndefined(property)) {
                var isEnum = _.isObject(pageForm.viewModel[property]) && !_.isUndefined(pageForm.viewModel[property].Id);
                if ((_.isNull(pageForm.viewModel[property]) || (pageForm.viewModel[property] === "")) ||
                    (_.isObject(pageForm.viewModel[property]) && isEnum && (_.isNull(pageForm.viewModel[property].Id) || pageForm.viewModel[property].Id === "")) ||
                    (((_.isObject(pageForm.viewModel[property]) && !isEnum && (_.isUndefined(pageForm.viewModel[property].BaseId) || _.isNull(pageForm.viewModel[property].BaseId)))))) {
                    valid = false;
                    jqEle.parents(".form-group").addClass("has-error");
                }
            }

            var nodeName = jqEle[0].nodeName.toLowerCase();
            if (nodeName != "input" && nodeName != "textarea") {
                jqEle = jqEle.find("input");
            }
            if (jqEle.val() == "") {
                valid = false;
                jqEle.parents(".form-group").addClass("has-error");
            }
        });
        if (!valid) {
            failure(localization.RequiredFieldsErrorMessage);
            return;
        }
        app.lib.mask.apply();
        
        current = dataVM.toJSON();

        //Assign Name to Display Name   
        current.DisplayName = current.Name; 

        var postDataRaw = {
            isDirty: true,
            current: current,
            original: pageForm.jsonRaw
        };

        var postData = getPostObject(postDataRaw);
        
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url: saveUrl,
            data: postData,
            contentType: 'application/json',
            success: function (data, status, xhr) {
                //make sure we set the dirty flag off
                dataVM.set("isDirty", false);

                //need this to be a string for the if statement below to work
                var dataAsString = JSON.stringify(data);
                if (dataAsString.search('loginForm') < 0) { // Logged out check                   
                    success(data);
                } else {
                    //session expired
                    window.location = "/Login/Login?ReturnUrl=" + window.location.pathname;
                }


            },
            error: function (xhr, ajaxOptions, thrownError) {
                failure();
                console && app.lib.log(localization.RequestFailed);
                app.lib.log(thrownError);

                var jsonRsp = xhr.responseText;
                app.lib.log(jsonRsp);

                var errorMsg = localization.RequestFailed;
                if (jsonRsp.exception && jsonRsp.exception.length > 0) {
                    errorMsg = jsonRsp.exception;
                }

                kendo.ui.ExtAlertDialog.show({
                    title: localization.ErrorDescription,
                    message:  errorMsg,
                    icon: "fa fa-exclamation"
                });
            },
            processData: false,
            async: false
        });
    }

    init();
});