﻿/* global define:true */
/* global app:true */

(function() {
	'use strict';

	define([
		'app'
	], function(ngApp) {

		ngApp.factory('pageService', ['$http', '$q', '$log', PageService]);

		function PageService($http, $q, $log) {

			var navigationAdminUrl = '/NavigationAdmin/';

			var service = {
				getNavigationNode: function () {
	                var d = $q.defer();
	                //*app.lib* exists in the global space, apart from angular
	                app.lib.getNavNode(function(matchedNode) {
	                    d.resolve(matchedNode);
	                });

	                return d.promise;
	            },

	            updateDefinition: function (guid, definition) {
	                var d = $q.defer();
	                var url = navigationAdminUrl + 'ChangeDefinition/';
	                var postData = {
	                    id: guid,
	                    definition: JSON.stringify(definition)
	                };
	                var postDataAsString = JSON.stringify(postData);
	                $http.post(url, postDataAsString)
	                    .success(function (data) {
	                        d.resolve(data);
	                        //*app* exists in the global space, apart from angular
	                        //refresh the nodes in session storage
	                        app.populateSessionStorage();
	                    }).error(function (data, status, headers, config) {
	                        $log.warn(data, status, headers(), config);
	                        d.reject(data);
	                    });

	                return d.promise;
	            }
			};

			return service;
		}
	});
})();