﻿/* global define: true */
/* global localization:true */

(function() {

	'use strict';

	define([
		'app'
	], function(app) {
		
	    app.provider('LocalizationService', [LocalizationService]);

	    function LocalizationService() {

	        this.$get = function ($http, $q) {

				var service = {
					getValue: function(key) {
						//*localization* exists in the global space, apart from angular 
						//if the value is found, return it; otherwise return the key,
						//so at least something meaninful can be displayed
						var value;
						if(localization[key]) {
							value = localization[key];
						} else {
						    value = key;
							// $log.info('No localization value found for:', key);
						}
						return value;
					},
					getKendoMessageUrl: function () {
					    var deferred = $q.defer();
					    $http.get("/Localizations/GetCurrentKendoCulture")
					        .then(function (response) {
					            var url = "/Scripts/kendo/2018.1.117/messages/kendo.messages." + response.data + ".min.js"
					            deferred.resolve(url);
					        }, function () {
					            notificationService.addError("Could not retrieve culture info");
					        });
					    return deferred.promise;
					}
				};

				return service;
			};
		}
	});

})();