﻿--*****************************************
-- Name: Create Data Insert Jobs for DW Lite  
--
-- Desc: Creates the Insert SQL Agent jobs 
--       that inserts new work items into 
--       tables in DW lite solution. 
--
--*****************************************


--*******************************************
--Create 'Cireson Insert New Changes' job 
--*******************************************

USE [msdb]
GO

/****** Object:  Job [Cireson Insert New Changes]    Script Date: 3/25/2016 10:34:30 AM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)
-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 3/25/2016 10:34:30 AM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Insert Display Strings', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Insert New Changes]    Script Date: 3/25/2016 10:34:31 AM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Insert New Changes', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000

WHILE 1 = 1
BEGIN
	--Insert Display Strings
-- Alias T = Target, S = Source
-- Merge statement for SM_DisplayString which is the Target.
MERGE INTO SM_DisplayString AS T USING
-- This area of SELECT statement only for DisplayString %ManagementDBName% which is the Source.
(SELECT
	ElementID,
	LocaleID,
	DisplayString,
	CreatedBy,
	CreatedDate,
	LastModifiedBy,
	LastModifiedDate,
	LocalizationKey,
	DisplayStringOverride,
	ContextNotes,
	SourceID
FROM [%ManagementDBName%].[dbo].DisplayString) AS S
ON T.ElementID = S.ElementID AND S.LocaleID = S.LocaleID
WHEN NOT MATCHED BY TARGET THEN 
INSERT(
	[ElementID],
	[LocaleID],
	[DisplayString],
	[CreatedBy],
	[CreatedDate],
	[LastModifiedBy],
	[LastModifiedDate],
	[LocalizationKey],
	[DisplayStringOverride],
	[ContextNotes],
	[SourceID]) 
VALUES (
	S.[ElementID],
	S.[LocaleID],
	S.[DisplayString],
	S.[CreatedBy],
	S.[CreatedDate],
	S.[LastModifiedBy],
	S.[LastModifiedDate],
	S.[LocalizationKey],
	S.[DisplayStringOverride],
	S.[ContextNotes],
	S.[SourceID]);

    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Insert Display Strings', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'0FF9BE3D-03BA-481A-A1D8-3FE13EF44ECA'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO