﻿
USE [msdb]
GO

/****** Object:  Job [Cireson Insert New Relationships]    Script Date: 4/23/2016 2:50:04 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)
-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 4/23/2016 2:50:04 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Insert New Relationships', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'This job inserts new relationship records from the ServiceManager database into SM_WI_Relationship.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Insert New Relationships]    Script Date: 4/23/2016 2:50:05 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Insert New Relationships', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000

WHILE 1 = 1
BEGIN
-- ************************************************************************
 --
 -- NAME: Relationship Data Extract and Insert 
 -- DESC: This query extracts relationship data from %SMDBName% DB and 
 --       inserts it into the Cireson DB 
 --
 --       If DBs have custom names, we need to address in this sample
-- ************************************************************************
-- Alias T = Target, S = Source
-- Merge statement for SM_WI_Relationship which is the Target.
MERGE INTO SM_WI_Relationship AS T USING
-- This area of SELECT statement only for WorkItem ServiceManagement which is the Source.
(SELECT R.[RelationshipId]
		,R.[SourceEntityId]
		,R.[TargetEntityId]
		,R.RelationshipTypeId
		,R.[IsDeleted]
		,R.[TimeAdded]
		,R.[LastModified]
	FROM [%SMDBName%].[dbo].[Relationship] R
	LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT1 ON (LT1.LTStringId = R.RelationshipTypeId AND LT1.LanguageCode = ''ENU'' AND LT1.LTStringType = 1)
	
	-- *********************************************************
	-- Filter to specific affected or related CIs pr WIs (all types) 
	-- 
	-- This additional filtering protects against unnecessary bloat
	-- in table size due to unnecessary records! 
	--
	-- Related items that have been removed will still appear 
	-- in this table with value of IsDeleted=1. We want to keep 
	-- these. We''ll filter these out in most of our report queries. 
	--
	-- *********************************************************

-- for ''Related CIs'' on Incident, Problem, Service Request
-- for ''Related Configuration Items: Computer, Services & People'' on RR
 AND (LT1.LTValue LIKE ''Is Related to Configuration Item''

-- for ''Affected CIs'' on a Incident, Service Request
-- AND for ''Config Items to Change'' on Change Requests
-- for ''Affected Business Services'' 
-- *** ''TEXT_TargetTypeID'' column to filter class of affected item ***
-- *** ''BME2_DisplayName'' column for display name of CI
 OR LT1.LTValue LIKE ''About Configuration Item''


-- for ''Related Work Items'' on Incidents, Service Request and Changes
-- for ''Related Work Items'' (usually Incidents) on a Problem
-- NOTE: to report on CHanges 
 OR LT1.LTValue LIKE ''Is Related to Work Item'')) AS S

       JOIN [%SMDBName%].[dbo].[BaseManagedEntity] BME1 ON BME1.BaseManagedEntityId = S.SourceEntityId
       JOIN [%SMDBName%].[dbo].[BaseManagedEntity] BME2 ON BME2.BaseManagedEntityId = S.TargetEntityId
       LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT1 ON (LT1.LTStringId = S.RelationshipTypeId AND LT1.LanguageCode = ''ENU'' AND LT1.LTStringType = 1)
       LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT2 ON (LT2.LTStringId = BME1.BaseManagedTypeId AND LT2.LanguageCode = ''ENU'' AND LT2.LTStringType = 1)
       LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT3 ON (LT3.LTStringId = BME2.BaseManagedTypeId AND LT3.LanguageCode = ''ENU'' AND LT3.LTStringType = 1)
    
	ON T.RelationshipId = S.RelationshipId
	  AND T.SourceEntityId = S.SourceEntityId
	  AND T.TargetEntityId = S.TargetEntityId
	  AND T.RelationshipTypeId = S.RelationshipTypeId 
	WHEN NOT MATCHED BY TARGET THEN 
	INSERT ([RelationshipId]
	,[SourceEntityId]
	,[TargetEntityId]
	,[RelationshipTypeId]
	,[IsDeleted]
	,[TimeAdded]
	,[LastModified]
	,[TEXT_RelationshipTypeId]
	,[SourceTypeId]
	,[SourceTypeDisplayName]
	,[TEXT_SourceTypeId]
	,[TargetTypeId]
	,[TargetTypeDisplayName]
	,[TEXT_TargetTypeId]) 
	VALUES (S.[RelationshipId]
	,S.[SourceEntityId]
	,S.[TargetEntityId]
	,S.[RelationshipTypeId]
	,S.[IsDeleted]
	,S.[TimeAdded]
	,S.[LastModified]
	,LT1.LTValue
	,BME1.BaseManagedTypeId
	,BME1.DisplayName
	,LT2.LTValue
	,BME2.BaseManagedTypeId
	,BME2.DisplayName
	,LT3.LTValue);

    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Insert New Relationships', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'd7912d88-b3b8-4d9d-be9a-ec826c6bb457'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO



