﻿--*****************************************
-- Name: Create Data Insert Jobs for DW Lite  
--
-- Desc: Creates the Insert SQL Agent jobs 
--       that inserts new work items into 
--       tables in DW lite solution. 
--
--*****************************************


--*******************************************
--Create 'Cireson Insert New Review Activities' job 
--*******************************************

/****** Object:  Job [Cireson Insert New Review Activities]    Script Date: 3/25/2016 10:40:15 AM ******/
USE [msdb]
GO
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)
-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 3/25/2016 10:40:15 AM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Insert New Review Activities', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Insert New Review Activities]    Script Date: 3/25/2016 10:40:15 AM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Insert New Review Activities', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000
DECLARE @locale NVARCHAR(MAX)
DECLARE @index INT
DECLARE @localeSetting NVARCHAR(MAX)
SET @localeSetting = (select TOP 1 [VALUE] from [%ManagementDBName%].[dbo].SettingsItem where [Key]=''LanguageCode'')
SET @locale = NULL
SET @index = CHARINDEX('','',@localeSetting)
IF @index <> 0
begin
	SET @locale = SUBSTRING(@localeSetting,0,CHARINDEX('','',@localeSetting))
end
WHILE 1 = 1
BEGIN
--Insert Review Activity

-- Alias T = Target, S = Source
-- Merge statement for SM_WorkItem_ReviewActivity which is the Target.
MERGE INTO SM_WorkItem_ReviewActivity AS T USING
-- This area of SELECT statement only for WorkItem %ManagementDBName% which is the Source.
(SELECT 
       [Id]
      ,[Title]
      ,[WorkItemId]
      ,[StatusId]
      ,[PriorityId]
      ,[AssignedUser]
      ,[AssignedUserId]
      ,[CreatedByUser]
      ,[CreatedByUserId]
      ,[AffectedUser]
      ,[AffectedUserId]
      ,[CategoryId]
      ,[TierId]
      ,[LastModified]
      ,[Created]
      ,[ClassId]
      ,[IsParent]
      ,[ParentWorkItemId]
      ,[ParentWorkItemType]
      ,[SoonestSLOBreachTime]
      ,[SoonestSLOWarningTime]
      ,[SLOStatus]
      ,[PrimaryOwner]
      ,[PrimaryOwnerId]
      ,[SourceId]
      ,[ScheduledStartDate]
      ,[ScheduledEndDate]
      ,[EffortRemaining]
      ,[EffortEstimate]
      ,[EffortCompleted]
      ,[PlannedCost]
      ,[ActualCost]
      ,[ActualDowntimeEndDate]
      ,[ActualDowntimeStartDate]
      ,[ActualEndDate]
      ,[ActualStartDate]
      ,[ContactMethod]
      ,[Description]
      ,[DisplayName]
      ,[FirstAssignedDate]
      ,[FirstResponseDate]
      ,[IsDowntime]
      ,[RequiredByDate]
      ,[ScheduledDowntimeEndDate]
      ,[ScheduledDowntimeStartDate]
      ,[ResolvedDate]
      ,[ApprovalCondition]
      ,[ApprovalPercentage]
      ,[BackoutPlan]
      ,[ClosedDate]
      ,[Comments]
      ,[CompletedDate]
      ,[Escalated]
	  ,[Impact]
      ,[ImplementationPlan]
      ,[ImplementationResults]
      ,[PostImplementationReview]
      ,[Reason]
      ,[Resolution]
      ,[ResolutionCategory]
      ,[ResolutionDescription]
	  ,[Risk]
      ,[RiskAssessmentPlan]
      ,[Skip]
      ,[TestPlan]
	  ,[Urgency]
      ,[Workarounds]
 from [%ManagementDBName%].[dbo].WorkItem
 WHERE ClassID = ''BFD90AAA-80DD-0FBB-6EAF-65D92C1D8E36'') AS S
  left join [%ManagementDBName%].[dbo].DisplayString StatusDS
  on S.[StatusId] = StatusDS.ElementID and StatusDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString PriorityDS
  on TRY_CAST(S.[PriorityId] as uniqueidentifier) = PriorityDS.ElementID and PriorityDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString CataegoryDS
  on S.[CategoryId] = CataegoryDS.ElementID and CataegoryDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString TierDS
  on S.[TierId] = TierDS.ElementID and TierDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString SourceDS
  on S.[SourceId] = SourceDS.ElementID and SourceDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString ImpactDS
  on S.[Impact] = ImpactDS.ElementID and ImpactDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString RiskDS
  on S.[Risk] = RiskDS.ElementID and RiskDS.LocaleID = ISNULL(@locale, ''ENU'')

  left join [%ManagementDBName%].[dbo].DisplayString UrgencyDS
  on S.[Urgency] = UrgencyDS.ElementID and UrgencyDS.LocaleID = ISNULL(@locale, ''ENU'')
 ON T.Id = S.Id
 WHEN NOT MATCHED BY TARGET THEN INSERT 
 ([Id]
      ,[Title]
      ,[WorkItemId]
      ,[StatusId]
	  ,[Status]
      ,[PriorityId]
	  ,[Priority]
      ,[AssignedUser]
      ,[AssignedUserId]
      ,[CreatedByUser]
      ,[CreatedByUserId]
      ,[AffectedUser]
      ,[AffectedUserId]
      ,[CategoryId]
	  ,[Category]
      ,[TierId]
	  ,[Tier]
      ,[LastModified]
      ,[Created]
      ,[ClassId]
      ,[IsParent]
      ,[ParentWorkItemId]
      ,[ParentWorkItemType]
      ,[SoonestSLOBreachTime]
      ,[SoonestSLOWarningTime]
      ,[SLOStatus]
      ,[PrimaryOwner]
      ,[PrimaryOwnerId]
      ,[SourceId]
	  ,[Source]
      ,[ScheduledStartDate]
      ,[ScheduledEndDate]
      ,[EffortRemaining]
      ,[EffortEstimate]
      ,[EffortCompleted]
      ,[PlannedCost]
      ,[ActualCost]
      ,[ActualDowntimeEndDate]
      ,[ActualDowntimeStartDate]
      ,[ActualEndDate]
      ,[ActualStartDate]
      ,[ContactMethod]
      ,[Description]
      ,[DisplayName]
      ,[FirstAssignedDate]
      ,[FirstResponseDate]
      ,[IsDowntime]
      ,[RequiredByDate]
      ,[ScheduledDowntimeEndDate]
      ,[ScheduledDowntimeStartDate]
      ,[ResolvedDate]
      ,[ApprovalCondition]
      ,[ApprovalPercentage]
      ,[BackoutPlan]
      ,[ClosedDate]
      ,[Comments]
      ,[CompletedDate]
      ,[Escalated]
      ,[ImpactId]
	  ,[Impact]
      ,[ImplementationPlan]
      ,[ImplementationResults]
      ,[PostImplementationReview]
      ,[Reason]
      ,[Resolution]
      ,[ResolutionCategory]
      ,[ResolutionDescription]
      ,[RiskId]
	  ,[Risk]
      ,[RiskAssessmentPlan]
      ,[Skip]
      ,[TestPlan]
	  ,[UrgencyId]
      ,[Urgency]
      ,[Workarounds]) 
 VALUES( S.[Id]
      ,S.[Title]
      ,S.[WorkItemId]
      ,S.[StatusId]
	  ,StatusDS.DisplayString
      ,S.[PriorityId]
	  ,PriorityDS.DisplayString
      ,S.[AssignedUser]
      ,S.[AssignedUserId]
      ,S.[CreatedByUser]
      ,S.[CreatedByUserId]
      ,S.[AffectedUser]
      ,S.[AffectedUserId]
      ,S.[CategoryId]
	  ,CataegoryDS.DisplayString
      ,S.[TierId]
	  ,TierDS.DisplayString
      ,S.[LastModified]
      ,S.[Created]
      ,S.[ClassId]
      ,S.[IsParent]
      ,S.[ParentWorkItemId]
      ,S.[ParentWorkItemType]
      ,S.[SoonestSLOBreachTime]
      ,S.[SoonestSLOWarningTime]
      ,S.[SLOStatus]
      ,S.[PrimaryOwner]
      ,S.[PrimaryOwnerId]
      ,S.[SourceId]
	  ,SourceDS.DisplayString
      ,S.[ScheduledStartDate]
      ,S.[ScheduledEndDate]
      ,S.[EffortRemaining]
      ,S.[EffortEstimate]
      ,S.[EffortCompleted]
      ,S.[PlannedCost]
      ,S.[ActualCost]
      ,S.[ActualDowntimeEndDate]
      ,S.[ActualDowntimeStartDate]
      ,S.[ActualEndDate]
      ,S.[ActualStartDate]
      ,S.[ContactMethod]
      ,S.[Description]
      ,S.[DisplayName]
      ,S.[FirstAssignedDate]
      ,S.[FirstResponseDate]
      ,S.[IsDowntime]
      ,S.[RequiredByDate]
      ,S.[ScheduledDowntimeEndDate]
      ,S.[ScheduledDowntimeStartDate]
      ,S.[ResolvedDate]
      ,S.[ApprovalCondition]
      ,S.[ApprovalPercentage]
      ,S.[BackoutPlan]
      ,S.[ClosedDate]
      ,S.[Comments]
      ,S.[CompletedDate]
      ,S.[Escalated]
      ,S.[Impact]
	  ,ImpactDS.DisplayString
      ,S.[ImplementationPlan]
      ,S.[ImplementationResults]
      ,S.[PostImplementationReview]
      ,S.[Reason]
      ,S.[Resolution]
      ,S.[ResolutionCategory]
      ,S.[ResolutionDescription]
      ,S.[Risk]
	  ,RiskDS.DisplayString
      ,S.[RiskAssessmentPlan]
      ,S.[Skip]
      ,S.[TestPlan]
	  ,S.[Urgency]
      ,UrgencyDS.DisplayString
      ,S.[Workarounds]);

    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Insert New Review Activities', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'24cadc55-7ff6-4d12-be25-70fc4aa34f01'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO