﻿--*******************************************
--Create 'Cireson Update Existing Incidents' job 
--*******************************************

USE [msdb]
GO

/****** Object:  Job [Cireson Update Existing Incidents]    Script Date: 3/25/2016 10:40:33 AM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)
-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 3/25/2016 10:40:33 AM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Update Existing Incidents', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Update Existing Incidents]    Script Date: 3/25/2016 10:40:33 AM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Update Existing Incidents', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=1, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000
DECLARE @locale NVARCHAR(MAX)
DECLARE @index INT
DECLARE @localeSetting NVARCHAR(MAX)
SET @localeSetting = (select TOP 1 [VALUE] from [%ManagementDBName%].[dbo].SettingsItem where [Key]=''LanguageCode'')
SET @locale = NULL
SET @index = CHARINDEX('','',@localeSetting)
IF @index <> 0
begin
	SET @locale = SUBSTRING(@localeSetting,0,CHARINDEX('','',@localeSetting))
end

WHILE 1 = 1
BEGIN
--Update Incidents 
UPDATE SM_WorkItem_Incident 
    SET [SM_WorkItem_Incident].[Title] = WI.[Title], 
	[SM_WorkItem_Incident].[WorkItemId] = WI.[WorkItemId], 
	[SM_WorkItem_Incident].[StatusId] = WI.[StatusId], 
	[SM_WorkItem_Incident].[PriorityId] = WI.[PriorityId], 
	[SM_WorkItem_Incident].[AssignedUser] = WI.[AssignedUser], 
	[SM_WorkItem_Incident].[AssignedUserId] = WI.[AssignedUserId], 
	[SM_WorkItem_Incident].[CreatedByUser] = WI.[CreatedByUser], 
	[SM_WorkItem_Incident].[CreatedByUserId] = WI.[CreatedByUserId],
	[SM_WorkItem_Incident].[AffectedUser] = WI.[AffectedUser],
    [SM_WorkItem_Incident].[AffectedUserId] = WI.[AffectedUserId],
    [SM_WorkItem_Incident].[CategoryId] = WI.[CategoryId],
	[SM_WorkItem_Incident].[TierId] = WI.[TierId],
	[SM_WorkItem_Incident].[LastModified] = WI.[LastModified],
	[SM_WorkItem_Incident].[Created] = WI.[Created],
	[SM_WorkItem_Incident].[ClassId] = WI.[ClassId],
	[SM_WorkItem_Incident].[IsParent] = WI.[IsParent],
	[SM_WorkItem_Incident].[ParentWorkItemId] = WI.[ParentWorkItemId],
	[SM_WorkItem_Incident].[ParentWorkItemType] = WI.[ParentWorkItemType],
	[SM_WorkItem_Incident].[SoonestSLOBreachTime] = WI.[SoonestSLOBreachTime],
	[SM_WorkItem_Incident].[SoonestSLOWarningTime] = WI.[SoonestSLOWarningTime],
	[SM_WorkItem_Incident].[SLOStatus] = WI.[SLOStatus],
	[SM_WorkItem_Incident].[PrimaryOwner] = WI.[PrimaryOwner],
	[SM_WorkItem_Incident].[PrimaryOwnerId] = WI.[PrimaryOwnerId],
	[SM_WorkItem_Incident].[SourceId] = WI.[SourceId],
	[SM_WorkItem_Incident].[ScheduledStartDate] = WI.[ScheduledStartDate],
	[SM_WorkItem_Incident].[ScheduledEndDate] = WI.[ScheduledEndDate],
	[SM_WorkItem_Incident].[EffortRemaining] = WI.[EffortRemaining],
	[SM_WorkItem_Incident].[EffortEstimate] = WI.[EffortEstimate],
	[SM_WorkItem_Incident].[EffortCompleted] = WI.[EffortCompleted],
	[SM_WorkItem_Incident].[PlannedCost] = WI.[PlannedCost],
	[SM_WorkItem_Incident].[ActualCost] = WI.[PlannedCost],
	[SM_WorkItem_Incident].[ActualDowntimeEndDate] = WI.[ActualDowntimeEndDate],
	[SM_WorkItem_Incident].[ActualDowntimeStartDate] = WI.[ActualDowntimeStartDate],
	[SM_WorkItem_Incident].[ActualEndDate] = WI.[ActualEndDate],
	[SM_WorkItem_Incident].[ActualStartDate] = WI.[ActualStartDate],
	[SM_WorkItem_Incident].[ContactMethod] = WI.[ContactMethod],
	[SM_WorkItem_Incident].[Description] = WI.[Description],
	[SM_WorkItem_Incident].[DisplayName] = WI.[DisplayName],
	[SM_WorkItem_Incident].[FirstAssignedDate] = WI.[FirstAssignedDate],
	[SM_WorkItem_Incident].[FirstResponseDate] = WI.[FirstResponseDate],
	[SM_WorkItem_Incident].[IsDowntime] = WI.[IsDowntime],
	[SM_WorkItem_Incident].[RequiredByDate] = WI.[RequiredByDate],
	[SM_WorkItem_Incident].[ScheduledDowntimeEndDate] = WI.[ScheduledDowntimeEndDate],
	[SM_WorkItem_Incident].[ScheduledDowntimeStartDate] = WI.[ScheduledDowntimeStartDate],
	[SM_WorkItem_Incident].[ResolvedDate] = WI.[ResolvedDate],
	[SM_WorkItem_Incident].[ApprovalCondition] = WI.[ApprovalCondition],
	[SM_WorkItem_Incident].[ApprovalPercentage] = WI.[ApprovalPercentage],
	[SM_WorkItem_Incident].[BackoutPlan] = WI.[BackoutPlan],
	[SM_WorkItem_Incident].[ClosedDate] = WI.[ClosedDate],
	[SM_WorkItem_Incident].[Comments] = WI.[Comments],
	[SM_WorkItem_Incident].[CompletedDate] = WI.[CompletedDate],
	[SM_WorkItem_Incident].[Escalated] = WI.[Escalated],
	[SM_WorkItem_Incident].[ImpactId] = WI.[Impact],
	[SM_WorkItem_Incident].[ImplementationPlan] = WI.[ImplementationPlan],
	[SM_WorkItem_Incident].[ImplementationResults] = WI.[ImplementationResults],
	[SM_WorkItem_Incident].[PostImplementationReview] = WI.[PostImplementationReview],
	[SM_WorkItem_Incident].[Reason] = WI.[Reason],
	[SM_WorkItem_Incident].[Resolution] = WI.[Resolution],
	[SM_WorkItem_Incident].[ResolutionCategory] = WI.[ResolutionCategory],
	[SM_WorkItem_Incident].[ResolutionDescription] = WI.[ResolutionDescription],
	[SM_WorkItem_Incident].[RiskId] = WI.[Risk],
	[SM_WorkItem_Incident].[RiskAssessmentPlan] = WI.[RiskAssessmentPlan],
	[SM_WorkItem_Incident].[Skip] = WI.[Skip],
	[SM_WorkItem_Incident].[TestPlan] = WI.[TestPlan],
	[SM_WorkItem_Incident].[UrgencyId] = WI.[Urgency],
	[SM_WorkItem_Incident].[Workarounds] = WI.[Workarounds],
	[SM_WorkItem_Incident].[Status] = StatusDS.DisplayString,
	[SM_WorkItem_Incident].[Category] = CataegoryDS.DisplayString,
	[SM_WorkItem_Incident].[Tier] = TierDS.DisplayString,
	[SM_WorkItem_Incident].[Source] = SourceDS.DisplayString,
	[SM_WorkItem_Incident].[Impact] = ImpactDS.DisplayString,
	[SM_WorkItem_Incident].[Risk] = RiskDS.DisplayString,
	[SM_WorkItem_Incident].[Urgency] = UrgencyDS.DisplayString
	
	
	FROM dbo.SM_WorkItem_Incident 
	INNER JOIN [%ManagementDBName%].[dbo].[WorkItem] WI
	ON [SM_WorkItem_Incident].ID = WI.ID 	
	left join [%ManagementDBName%].[dbo].DisplayString StatusDS
	on WI.[StatusId] = StatusDS.ElementID and StatusDS.LocaleID = ISNULL(@locale, ''ENU'')
	
	left join [%ManagementDBName%].[dbo].DisplayString CataegoryDS
	on WI.[CategoryId] = CataegoryDS.ElementID and CataegoryDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString TierDS
	on WI.[TierId] = TierDS.ElementID and TierDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString SourceDS
	on WI.[SourceId] = SourceDS.ElementID and SourceDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString ImpactDS
	on WI.[Impact] = ImpactDS.ElementID and ImpactDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString RiskDS
	on WI.[Risk] = RiskDS.ElementID and RiskDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString UrgencyDS
	on WI.[Urgency] = UrgencyDS.ElementID and UrgencyDS.LocaleID = ISNULL(@locale, ''ENU'')

	WHERE WI.LastModified > [SM_WorkItem_Incident].LastModified
	
    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Update Existing Incidents', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'2e3aafbc-ad7f-44bc-b301-5f7fc70fbb41'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO