﻿--*******************************************
--Create 'Cireson Update Existing Problems' job 
--*******************************************

USE [msdb]
GO

/****** Object:  Job [Cireson Update Existing Problems]    Script Date: 3/25/2016 10:40:42 AM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)
-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 3/25/2016 10:40:42 AM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Update Existing Problems', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Update Existing Problems]    Script Date: 3/25/2016 10:40:42 AM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Update Existing Problems', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000
DECLARE @locale NVARCHAR(MAX)
DECLARE @index INT
DECLARE @localeSetting NVARCHAR(MAX)
SET @localeSetting = (select TOP 1 [VALUE] from [%ManagementDBName%].[dbo].SettingsItem where [Key]=''LanguageCode'')
SET @locale = NULL
SET @index = CHARINDEX('','',@localeSetting)
IF @index <> 0
begin
	SET @locale = SUBSTRING(@localeSetting,0,CHARINDEX('','',@localeSetting))
end

WHILE 1 = 1
BEGIN
	--Update Problems  
	UPDATE SM_WorkItem_Problem SET
    [SM_WorkItem_Problem].[Title] = WI.[Title], 
	[SM_WorkItem_Problem].[WorkItemId] = WI.[WorkItemId], 
	[SM_WorkItem_Problem].[StatusId] = WI.[StatusId], 
	[SM_WorkItem_Problem].[PriorityId] = WI.[PriorityId], 
	[SM_WorkItem_Problem].[AssignedUser] = WI.[AssignedUser], 
	[SM_WorkItem_Problem].[AssignedUserId] = WI.[AssignedUserId], 
	[SM_WorkItem_Problem].[CreatedByUser] = WI.[CreatedByUser], 
	[SM_WorkItem_Problem].[CreatedByUserId] = WI.[CreatedByUserId],
	[SM_WorkItem_Problem].[AffectedUser] = WI.[AffectedUser],
    [SM_WorkItem_Problem].[AffectedUserId] = WI.[AffectedUserId],
    [SM_WorkItem_Problem].[CategoryId] = WI.[CategoryId],
	[SM_WorkItem_Problem].[TierId] = WI.[TierId],
	[SM_WorkItem_Problem].[LastModified] = WI.[LastModified],
	[SM_WorkItem_Problem].[Created] = WI.[Created],
	[SM_WorkItem_Problem].[ClassId] = WI.[ClassId],
	[SM_WorkItem_Problem].[IsParent] = WI.[IsParent],
	[SM_WorkItem_Problem].[ParentWorkItemId] = WI.[ParentWorkItemId],
	[SM_WorkItem_Problem].[ParentWorkItemType] = WI.[ParentWorkItemType],
	[SM_WorkItem_Problem].[SoonestSLOBreachTime] = WI.[SoonestSLOBreachTime],
	[SM_WorkItem_Problem].[SoonestSLOWarningTime] = WI.[SoonestSLOWarningTime],
	[SM_WorkItem_Problem].[SLOStatus] = WI.[SLOStatus],
	[SM_WorkItem_Problem].[PrimaryOwner] = WI.[PrimaryOwner],
	[SM_WorkItem_Problem].[PrimaryOwnerId] = WI.[PrimaryOwnerId],
	[SM_WorkItem_Problem].[SourceId] = WI.[SourceId],
	[SM_WorkItem_Problem].[ScheduledStartDate] = WI.[ScheduledStartDate],
	[SM_WorkItem_Problem].[ScheduledEndDate] = WI.[ScheduledEndDate],
	[SM_WorkItem_Problem].[EffortRemaining] = WI.[EffortRemaining],
	[SM_WorkItem_Problem].[EffortEstimate] = WI.[EffortEstimate],
	[SM_WorkItem_Problem].[EffortCompleted] = WI.[EffortCompleted],
	[SM_WorkItem_Problem].[PlannedCost] = WI.[PlannedCost],
	[SM_WorkItem_Problem].[ActualCost] = WI.[PlannedCost],
	[SM_WorkItem_Problem].[ActualDowntimeEndDate] = WI.[ActualDowntimeEndDate],
	[SM_WorkItem_Problem].[ActualDowntimeStartDate] = WI.[ActualDowntimeStartDate],
	[SM_WorkItem_Problem].[ActualEndDate] = WI.[ActualEndDate],
	[SM_WorkItem_Problem].[ActualStartDate] = WI.[ActualStartDate],
	[SM_WorkItem_Problem].[ContactMethod] = WI.[ContactMethod],
	[SM_WorkItem_Problem].[Description] = WI.[Description],
	[SM_WorkItem_Problem].[DisplayName] = WI.[DisplayName],
	[SM_WorkItem_Problem].[FirstAssignedDate] = WI.[FirstAssignedDate],
	[SM_WorkItem_Problem].[FirstResponseDate] = WI.[FirstResponseDate],
	[SM_WorkItem_Problem].[IsDowntime] = WI.[IsDowntime],
	[SM_WorkItem_Problem].[RequiredByDate] = WI.[RequiredByDate],
	[SM_WorkItem_Problem].[ScheduledDowntimeEndDate] = WI.[ScheduledDowntimeEndDate],
	[SM_WorkItem_Problem].[ScheduledDowntimeStartDate] = WI.[ScheduledDowntimeStartDate],
	[SM_WorkItem_Problem].[ResolvedDate] = WI.[ResolvedDate],
	[SM_WorkItem_Problem].[ApprovalCondition] = WI.[ApprovalCondition],
	[SM_WorkItem_Problem].[ApprovalPercentage] = WI.[ApprovalPercentage],
	[SM_WorkItem_Problem].[BackoutPlan] = WI.[BackoutPlan],
	[SM_WorkItem_Problem].[ClosedDate] = WI.[ClosedDate],
	[SM_WorkItem_Problem].[Comments] = WI.[Comments],
	[SM_WorkItem_Problem].[CompletedDate] = WI.[CompletedDate],
	[SM_WorkItem_Problem].[Escalated] = WI.[Escalated],
	[SM_WorkItem_Problem].[ImpactId] = WI.[Impact],
	[SM_WorkItem_Problem].[ImplementationPlan] = WI.[ImplementationPlan],
	[SM_WorkItem_Problem].[ImplementationResults] = WI.[ImplementationResults],
	[SM_WorkItem_Problem].[PostImplementationReview] = WI.[PostImplementationReview],
	[SM_WorkItem_Problem].[Reason] = WI.[Reason],
	[SM_WorkItem_Problem].[Resolution] = WI.[Resolution],
	[SM_WorkItem_Problem].[ResolutionCategory] = WI.[ResolutionCategory],
	[SM_WorkItem_Problem].[ResolutionDescription] = WI.[ResolutionDescription],
	[SM_WorkItem_Problem].[RiskId] = WI.[Risk],
	[SM_WorkItem_Problem].[RiskAssessmentPlan] = WI.[RiskAssessmentPlan],
	[SM_WorkItem_Problem].[Skip] = WI.[Skip],
	[SM_WorkItem_Problem].[TestPlan] = WI.[TestPlan],
	[SM_WorkItem_Problem].[UrgencyId] = WI.[Urgency],
	[SM_WorkItem_Problem].[Workarounds] = WI.[Workarounds],
	[SM_WorkItem_Problem].[Status] = StatusDS.DisplayString,
	[SM_WorkItem_Problem].[Category] = CataegoryDS.DisplayString,
	[SM_WorkItem_Problem].[Tier] = TierDS.DisplayString,
	[SM_WorkItem_Problem].[Source] = SourceDS.DisplayString,
	[SM_WorkItem_Problem].[Impact] = ImpactDS.DisplayString,
	[SM_WorkItem_Problem].[Risk] = RiskDS.DisplayString,
	[SM_WorkItem_Problem].[Urgency] = UrgencyDS.DisplayString
	
	
	FROM dbo.SM_WorkItem_Problem 
	INNER JOIN [%ManagementDBName%].[dbo].[WorkItem] WI
	ON [SM_WorkItem_Problem].ID = WI.ID 	
	left join [%ManagementDBName%].[dbo].DisplayString StatusDS
	on WI.[StatusId] = StatusDS.ElementID and StatusDS.LocaleID = ISNULL(@locale, ''ENU'')
	
	left join [%ManagementDBName%].[dbo].DisplayString CataegoryDS
	on WI.[CategoryId] = CataegoryDS.ElementID and CataegoryDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString TierDS
	on WI.[TierId] = TierDS.ElementID and TierDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString SourceDS
	on WI.[SourceId] = SourceDS.ElementID and SourceDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString ImpactDS
	on WI.[Impact] = ImpactDS.ElementID and ImpactDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString RiskDS
	on WI.[Risk] = RiskDS.ElementID and RiskDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString UrgencyDS
	on WI.[Urgency] = UrgencyDS.ElementID and UrgencyDS.LocaleID = ISNULL(@locale, ''ENU'')

	WHERE WI.LastModified > [SM_WorkItem_Problem].LastModified
	
    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Update Existing Problems', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'ba78a628-15ca-4699-bf02-bc1f20ca585b'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO