﻿USE [msdb]
GO

/****** Object:  Job [Cireson Update Existing Relationships]    Script Date: 4/23/2016 5:20:53 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)

-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 4/23/2016 5:20:53 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Update Existing Relationships', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Update Existing Relationships]    Script Date: 4/23/2016 5:20:54 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Update Existing Relationships', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000

WHILE 1 = 1
BEGIN
	--Update Relationships 
	UPDATE [SM_WI_Relationship] SET
		 
	--No need to update the PK values (would violate the constraint anyway). 
	--[SM_WI_Relationship].[RelationshipID] = R.RelationshipTypeId,
	--[SM_WI_Relationship].[SourceEntityId] = R.SourceEntityId,
	--[SM_WI_Relationship].[TargetEntityId] = R.TargetEntityId,
	--[SM_WI_Relationship].[RelationshipTypeId] = R.RelationshipTypeId,
	[SM_WI_Relationship].[IsDeleted] = R.IsDeleted,
	[SM_WI_Relationship].[TimeAdded] = R.TimeAdded,
	[SM_WI_Relationship].[LastModified] = R.LastModified,
	[SM_WI_Relationship].[TEXT_RelationshipTypeId] = LT1.LTValue,
	[SM_WI_Relationship].[SourceTypeId] = BME1.BaseManagedTypeId,
	[SM_WI_Relationship].[SourceTypeDisplayName] = BME1.DisplayName,
	[SM_WI_Relationship].[TEXT_SourceTypeId] = LT2.LTValue, 
	[SM_WI_Relationship].[TargetTypeId] = BME2.BaseManagedTypeId,
	[SM_WI_Relationship].[TargetTypeDisplayName] = BME2.DisplayName,
	[SM_WI_Relationship].[TEXT_TargetTypeId] = LT3.LTValue

    FROM [SM_WI_Relationship] WIR

	INNER JOIN [%SMDBName%].[dbo].[Relationship] R ON WIR.RelationshipId = R.RelationshipId

    INNER JOIN [%SMDBName%].[dbo].[BaseManagedEntity] BME1 ON BME1.BaseManagedEntityId = R.SourceEntityId

    INNER JOIN [%SMDBName%].[dbo].[BaseManagedEntity] BME2 ON BME2.BaseManagedEntityId = R.TargetEntityId

    LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT1 ON (LT1.LTStringId = R.RelationshipTypeId AND LT1.LanguageCode = ''ENU'' AND LT1.LTStringType = 1)

    LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT2 ON (LT2.LTStringId = BME1.BaseManagedTypeId AND LT2.LanguageCode = ''ENU'' AND LT2.LTStringType = 1)

    LEFT JOIN [%SMDBName%].[dbo].[LocalizedText] LT3 ON (LT3.LTStringId = BME2.BaseManagedTypeId AND LT3.LanguageCode = ''ENU'' AND LT3.LTStringType = 1)

	WHERE (WIR.RelationshipID = R.RelationshipId
		  AND WIR.SourceEntityId = R.SourceEntityId
		  AND WIR.TargetEntityId = R.TargetEntityId
		  AND WIR.RelationshipTypeId = R.RelationshipTypeId
		
	-- Matching only one LastModified value will not get updates to display strings 
	-- (in LocalizedText and BaseManagedEntity tables), but we don''t need these for 
	-- ''Top X'' reports. Will think on any implications this may have. 

	      AND (WIR.LastModified < R.LastModified))

    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Update Existing Relationships', 
		@enabled=1, 
		@freq_type=8, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=1, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'be7659bd-b4a4-4224-b32d-6bedd040b37c'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO

