﻿--*******************************************
--Create 'Cireson Update Existing Service Requests' job 
--*******************************************

USE [msdb]
GO

/****** Object:  Job [Cireson Update Existing Service Requests]    Script Date: 3/25/2016 10:40:51 AM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

--define the database
DECLARE @database NVARCHAR(MAX)
-- Change %AnalyticDBName% into CiresonAnalytics for debugging
SET @database = N'%AnalyticDBName%'

--get the db owner
DECLARE @dbowner NVARCHAR(MAX)
BEGIN
SELECT @dbowner = suser_sname(owner_sid)
  FROM sys.databases
 WHERE name=@database
END

/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 3/25/2016 10:40:51 AM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Cireson Update Existing Service Requests', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=@dbowner, @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cireson Update Existing Service Requests]    Script Date: 3/25/2016 10:40:51 AM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cireson Update Existing Service Requests', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @BatchSize INT = 10000
DECLARE @locale NVARCHAR(MAX)
DECLARE @index INT
DECLARE @localeSetting NVARCHAR(MAX)
SET @localeSetting = (select TOP 1 [VALUE] from [%ManagementDBName%].[dbo].SettingsItem where [Key]=''LanguageCode'')
SET @locale = NULL
SET @index = CHARINDEX('','',@localeSetting)
IF @index <> 0
begin
	SET @locale = SUBSTRING(@localeSetting,0,CHARINDEX('','',@localeSetting))
end

WHILE 1 = 1
BEGIN
	--Update Service Requests
	UPDATE SM_WorkItem_ServiceRequest SET
    [SM_WorkItem_ServiceRequest].[Title] = WI.[Title], 
	[SM_WorkItem_ServiceRequest].[WorkItemId] = WI.[WorkItemId], 
	[SM_WorkItem_ServiceRequest].[StatusId] = WI.[StatusId], 
	[SM_WorkItem_ServiceRequest].[PriorityId] = WI.[PriorityId], 
	[SM_WorkItem_ServiceRequest].[AssignedUser] = WI.[AssignedUser], 
	[SM_WorkItem_ServiceRequest].[AssignedUserId] = WI.[AssignedUserId], 
	[SM_WorkItem_ServiceRequest].[CreatedByUser] = WI.[CreatedByUser], 
	[SM_WorkItem_ServiceRequest].[CreatedByUserId] = WI.[CreatedByUserId],
	[SM_WorkItem_ServiceRequest].[AffectedUser] = WI.[AffectedUser],
    [SM_WorkItem_ServiceRequest].[AffectedUserId] = WI.[AffectedUserId],
    [SM_WorkItem_ServiceRequest].[CategoryId] = WI.[CategoryId],
	[SM_WorkItem_ServiceRequest].[TierId] = WI.[TierId],
	[SM_WorkItem_ServiceRequest].[LastModified] = WI.[LastModified],
	[SM_WorkItem_ServiceRequest].[Created] = WI.[Created],
	[SM_WorkItem_ServiceRequest].[ClassId] = WI.[ClassId],
	[SM_WorkItem_ServiceRequest].[IsParent] = WI.[IsParent],
	[SM_WorkItem_ServiceRequest].[ParentWorkItemId] = WI.[ParentWorkItemId],
	[SM_WorkItem_ServiceRequest].[ParentWorkItemType] = WI.[ParentWorkItemType],
	[SM_WorkItem_ServiceRequest].[SoonestSLOBreachTime] = WI.[SoonestSLOBreachTime],
	[SM_WorkItem_ServiceRequest].[SoonestSLOWarningTime] = WI.[SoonestSLOWarningTime],
	[SM_WorkItem_ServiceRequest].[SLOStatus] = WI.[SLOStatus],
	[SM_WorkItem_ServiceRequest].[PrimaryOwner] = WI.[PrimaryOwner],
	[SM_WorkItem_ServiceRequest].[PrimaryOwnerId] = WI.[PrimaryOwnerId],
	[SM_WorkItem_ServiceRequest].[SourceId] = WI.[SourceId],
	[SM_WorkItem_ServiceRequest].[ScheduledStartDate] = WI.[ScheduledStartDate],
	[SM_WorkItem_ServiceRequest].[ScheduledEndDate] = WI.[ScheduledEndDate],
	[SM_WorkItem_ServiceRequest].[EffortRemaining] = WI.[EffortRemaining],
	[SM_WorkItem_ServiceRequest].[EffortEstimate] = WI.[EffortEstimate],
	[SM_WorkItem_ServiceRequest].[EffortCompleted] = WI.[EffortCompleted],
	[SM_WorkItem_ServiceRequest].[PlannedCost] = WI.[PlannedCost],
	[SM_WorkItem_ServiceRequest].[ActualCost] = WI.[PlannedCost],
	[SM_WorkItem_ServiceRequest].[ActualDowntimeEndDate] = WI.[ActualDowntimeEndDate],
	[SM_WorkItem_ServiceRequest].[ActualDowntimeStartDate] = WI.[ActualDowntimeStartDate],
	[SM_WorkItem_ServiceRequest].[ActualEndDate] = WI.[ActualEndDate],
	[SM_WorkItem_ServiceRequest].[ActualStartDate] = WI.[ActualStartDate],
	[SM_WorkItem_ServiceRequest].[ContactMethod] = WI.[ContactMethod],
	[SM_WorkItem_ServiceRequest].[Description] = WI.[Description],
	[SM_WorkItem_ServiceRequest].[DisplayName] = WI.[DisplayName],
	[SM_WorkItem_ServiceRequest].[FirstAssignedDate] = WI.[FirstAssignedDate],
	[SM_WorkItem_ServiceRequest].[FirstResponseDate] = WI.[FirstResponseDate],
	[SM_WorkItem_ServiceRequest].[IsDowntime] = WI.[IsDowntime],
	[SM_WorkItem_ServiceRequest].[RequiredByDate] = WI.[RequiredByDate],
	[SM_WorkItem_ServiceRequest].[ScheduledDowntimeEndDate] = WI.[ScheduledDowntimeEndDate],
	[SM_WorkItem_ServiceRequest].[ScheduledDowntimeStartDate] = WI.[ScheduledDowntimeStartDate],
	[SM_WorkItem_ServiceRequest].[ResolvedDate] = WI.[ResolvedDate],
	[SM_WorkItem_ServiceRequest].[ApprovalCondition] = WI.[ApprovalCondition],
	[SM_WorkItem_ServiceRequest].[ApprovalPercentage] = WI.[ApprovalPercentage],
	[SM_WorkItem_ServiceRequest].[BackoutPlan] = WI.[BackoutPlan],
	[SM_WorkItem_ServiceRequest].[ClosedDate] = WI.[ClosedDate],
	[SM_WorkItem_ServiceRequest].[Comments] = WI.[Comments],
	[SM_WorkItem_ServiceRequest].[CompletedDate] = WI.[CompletedDate],
	[SM_WorkItem_ServiceRequest].[Escalated] = WI.[Escalated],
	[SM_WorkItem_ServiceRequest].[ImpactId] = WI.[Impact],
	[SM_WorkItem_ServiceRequest].[ImplementationPlan] = WI.[ImplementationPlan],
	[SM_WorkItem_ServiceRequest].[ImplementationResults] = WI.[ImplementationResults],
	[SM_WorkItem_ServiceRequest].[PostImplementationReview] = WI.[PostImplementationReview],
	[SM_WorkItem_ServiceRequest].[Reason] = WI.[Reason],
	[SM_WorkItem_ServiceRequest].[Resolution] = WI.[Resolution],
	[SM_WorkItem_ServiceRequest].[ResolutionCategory] = WI.[ResolutionCategory],
	[SM_WorkItem_ServiceRequest].[ResolutionDescription] = WI.[ResolutionDescription],
	[SM_WorkItem_ServiceRequest].[RiskId] = WI.[Risk],
	[SM_WorkItem_ServiceRequest].[RiskAssessmentPlan] = WI.[RiskAssessmentPlan],
	[SM_WorkItem_ServiceRequest].[Skip] = WI.[Skip],
	[SM_WorkItem_ServiceRequest].[TestPlan] = WI.[TestPlan],
	[SM_WorkItem_ServiceRequest].[UrgencyId] = WI.[Urgency],
	[SM_WorkItem_ServiceRequest].[Workarounds] = WI.[Workarounds],
	[SM_WorkItem_ServiceRequest].[Status] = StatusDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Priority] = PriorityDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Category] = CataegoryDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Tier] = TierDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Source] = SourceDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Impact] = ImpactDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Risk] = RiskDS.DisplayString,
	[SM_WorkItem_ServiceRequest].[Urgency] = UrgencyDS.DisplayString
	FROM dbo.SM_WorkItem_ServiceRequest 
	INNER JOIN [%ManagementDBName%].[dbo].[WorkItem] WI
	ON [SM_WorkItem_ServiceRequest].ID = WI.ID 	

	left join [%ManagementDBName%].[dbo].DisplayString StatusDS
	on WI.[StatusId] = StatusDS.ElementID and StatusDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString PriorityDS
	on TRY_CAST(WI.[PriorityId] as uniqueidentifier) = PriorityDS.ElementID and PriorityDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString CataegoryDS
	on WI.[CategoryId] = CataegoryDS.ElementID and CataegoryDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString TierDS
	on WI.[TierId] = TierDS.ElementID and TierDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString SourceDS
	on WI.[SourceId] = SourceDS.ElementID and SourceDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString ImpactDS
	on WI.[Impact] = ImpactDS.ElementID and ImpactDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString RiskDS
	on WI.[Risk] = RiskDS.ElementID and RiskDS.LocaleID = ISNULL(@locale, ''ENU'')

	left join [%ManagementDBName%].[dbo].DisplayString UrgencyDS
	on WI.[Urgency] = UrgencyDS.ElementID and UrgencyDS.LocaleID = ISNULL(@locale, ''ENU'')

	WHERE WI.LastModified > [SM_WorkItem_ServiceRequest].LastModified

    IF @@ROWCOUNT < @BatchSize BREAK
    
END', 
		@database_name=@database, 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Cireson Update Existing Service Requests', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=N'%AnalyticFrequency%', 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=N'%AnalyticFrequencyStartDate%', 
		@active_end_date=99991231, 
		@active_start_time=N'%AnalyticFrequencyStartTime%', 
		@active_end_time=235959, 
		@schedule_uid=N'f6a1b49a-0dab-4fca-843c-aac9d8eb5662'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO